/* ai.c generated by valac 0.46.2, the Vala compiler
 * generated from ai.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright © 2014 Nikhar Agrawal
 *
 * This file is part of Four-in-a-row.
 *
 * Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 *(at your option) any later version.
 *
 * Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Four-in-a-row.  If not, see <http://www.gnu.org/licenses/>. */
/* Here NEG_INF is supposed to be the lowest possible int value. int.MIN
MAX_HEURIST_VALUE is the maximum value that the heuristic functions can return.
It is returned when AI wins. -1*MAX_HEURIST_VALUE is returned when Human wins
MAX_HEURIST_VALUE < NEG_INF/plies */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>

typedef enum  {
	PLAYER_NONE,
	PLAYER_HUMAN,
	PLAYER_AI
} Player;

#define TYPE_PLAYER (player_get_type ())
typedef enum  {
	DIFFICULTY_EASY,
	DIFFICULTY_MEDIUM,
	DIFFICULTY_HARD
} Difficulty;

#define TYPE_DIFFICULTY (difficulty_get_type ())

#define TYPE_DECISION_TREE (decision_tree_get_type ())
#define DECISION_TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DECISION_TREE, DecisionTree))
#define DECISION_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DECISION_TREE, DecisionTreeClass))
#define IS_DECISION_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DECISION_TREE))
#define IS_DECISION_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DECISION_TREE))
#define DECISION_TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DECISION_TREE, DecisionTreeClass))

typedef struct _DecisionTree DecisionTree;
typedef struct _DecisionTreeClass DecisionTreeClass;
#define _decision_tree_unref0(var) ((var == NULL) ? NULL : (var = (decision_tree_unref (var), NULL)))
typedef struct _DecisionTreePrivate DecisionTreePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecDecisionTree ParamSpecDecisionTree;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _DecisionTree {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DecisionTreePrivate * priv;
};

struct _DecisionTreeClass {
	GTypeClass parent_class;
	void (*finalize) (DecisionTree *self);
};

struct _DecisionTreePrivate {
	Player* board;
	gint board_length1;
	gint board_length2;
	gint plies;
	Player last_moving_player;
	gint next_move_in_column;
	Difficulty level;
};

struct _ParamSpecDecisionTree {
	GParamSpec parent_instance;
};

static gint DecisionTree_private_offset;
static gpointer decision_tree_parent_class = NULL;

#define NEG_INF -100000
#define MAX_HEURIST_VALUE 10000
#define BOARD_ROWS 6
#define BOARD_COLUMNS 7
GType player_get_type (void) G_GNUC_CONST;
GType difficulty_get_type (void) G_GNUC_CONST;
gint playgame (const gchar* moves_until_now);
gpointer decision_tree_ref (gpointer instance);
void decision_tree_unref (gpointer instance);
GParamSpec* param_spec_decision_tree (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_decision_tree (GValue* value,
                              gpointer v_object);
void value_take_decision_tree (GValue* value,
                               gpointer v_object);
gpointer value_get_decision_tree (const GValue* value);
GType decision_tree_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DecisionTree, decision_tree_unref)
DecisionTree* decision_tree_new (void);
DecisionTree* decision_tree_construct (GType object_type);
gint decision_tree_playgame (DecisionTree* self,
                             const gchar* vstr);
void decision_tree_print_board (DecisionTree* self);
static gint decision_tree_negamax (DecisionTree* self,
                            gint height,
                            gint alpha,
                            gint beta);
static gboolean decision_tree_board_full (DecisionTree* self);
static gint decision_tree_heurist (DecisionTree* self);
static gboolean decision_tree_move (DecisionTree* self,
                             gint column);
static gboolean decision_tree_victory (DecisionTree* self,
                                gint column);
static void decision_tree_unmove (DecisionTree* self,
                           gint column);
static gboolean decision_tree_vertical_win (DecisionTree* self,
                                     gint i,
                                     gint j);
static gboolean decision_tree_horizontal_win (DecisionTree* self,
                                       gint i,
                                       gint j);
static gboolean decision_tree_forward_diagonal_win (DecisionTree* self,
                                             gint i,
                                             gint j);
static gboolean decision_tree_backward_diagonal_win (DecisionTree* self,
                                              gint i,
                                              gint j);
void decision_tree_update_board (DecisionTree* self,
                                 const gchar* vstr);
static gint decision_tree_immediate_win (DecisionTree* self,
                                  Player p);
static void decision_tree_set_level (DecisionTree* self,
                              const gchar* vstr);
static gint decision_tree_heurist_easy (DecisionTree* self);
static gint decision_tree_heurist_medium (DecisionTree* self);
static gint decision_tree_heurist_hard (DecisionTree* self);
static gint decision_tree_count_3_in_a_row (DecisionTree* self,
                                     Player p);
static gboolean decision_tree_all_adjacent_empty (DecisionTree* self,
                                           gint i,
                                           gint j);
gint decision_tree_playandcheck (DecisionTree* self,
                                 const gchar* vstr);
static void decision_tree_finalize (DecisionTree * obj);

GType
player_get_type (void)
{
	static volatile gsize player_type_id__volatile = 0;
	if (g_once_init_enter (&player_type_id__volatile)) {
		static const GEnumValue values[] = {{PLAYER_NONE, "PLAYER_NONE", "none"}, {PLAYER_HUMAN, "PLAYER_HUMAN", "human"}, {PLAYER_AI, "PLAYER_AI", "ai"}, {0, NULL, NULL}};
		GType player_type_id;
		player_type_id = g_enum_register_static ("Player", values);
		g_once_init_leave (&player_type_id__volatile, player_type_id);
	}
	return player_type_id__volatile;
}

GType
difficulty_get_type (void)
{
	static volatile gsize difficulty_type_id__volatile = 0;
	if (g_once_init_enter (&difficulty_type_id__volatile)) {
		static const GEnumValue values[] = {{DIFFICULTY_EASY, "DIFFICULTY_EASY", "easy"}, {DIFFICULTY_MEDIUM, "DIFFICULTY_MEDIUM", "medium"}, {DIFFICULTY_HARD, "DIFFICULTY_HARD", "hard"}, {0, NULL, NULL}};
		GType difficulty_type_id;
		difficulty_type_id = g_enum_register_static ("Difficulty", values);
		g_once_init_leave (&difficulty_type_id__volatile, difficulty_type_id);
	}
	return difficulty_type_id__volatile;
}

gint
playgame (const gchar* moves_until_now)
{
	DecisionTree* t = NULL;
	DecisionTree* _tmp0_;
	gint result = 0;
	g_return_val_if_fail (moves_until_now != NULL, 0);
	_tmp0_ = decision_tree_new ();
	t = _tmp0_;
	result = decision_tree_playgame (t, moves_until_now);
	_decision_tree_unref0 (t);
	return result;
}

static inline gpointer
decision_tree_get_instance_private (DecisionTree* self)
{
	return G_STRUCT_MEMBER_P (self, DecisionTree_private_offset);
}

DecisionTree*
decision_tree_construct (GType object_type)
{
	DecisionTree* self = NULL;
	self = (DecisionTree*) g_type_create_instance (object_type);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < BOARD_ROWS)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							Player* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							if (!_tmp2_) {
								gint _tmp3_;
								_tmp3_ = j;
								j = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(j < BOARD_COLUMNS)) {
								break;
							}
							_tmp4_ = self->priv->board;
							_tmp4__length1 = self->priv->board_length1;
							_tmp4__length2 = self->priv->board_length2;
							_tmp4_[(i * _tmp4__length2) + j] = PLAYER_NONE;
						}
					}
				}
			}
		}
	}
	return self;
}

DecisionTree*
decision_tree_new (void)
{
	return decision_tree_construct (TYPE_DECISION_TREE);
}

void
decision_tree_print_board (DecisionTree* self)
{
	FILE* _tmp8_;
	g_return_if_fail (self != NULL);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				FILE* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < BOARD_ROWS)) {
					break;
				}
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							FILE* _tmp4_;
							Player* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Player _tmp6_;
							if (!_tmp2_) {
								gint _tmp3_;
								_tmp3_ = j;
								j = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(j < BOARD_COLUMNS)) {
								break;
							}
							_tmp4_ = stdout;
							_tmp5_ = self->priv->board;
							_tmp5__length1 = self->priv->board_length1;
							_tmp5__length2 = self->priv->board_length2;
							_tmp6_ = _tmp5_[(i * _tmp5__length2) + j];
							fprintf (_tmp4_, "%d\t", (gint) _tmp6_);
						}
					}
				}
				_tmp7_ = stdout;
				fprintf (_tmp7_, "\n");
			}
		}
	}
	_tmp8_ = stdout;
	fprintf (_tmp8_, "\n");
}

static gint
decision_tree_negamax (DecisionTree* self,
                       gint height,
                       gint alpha,
                       gint beta)
{
	gboolean _tmp0_ = FALSE;
	gint max = 0;
	gint next = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (height == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = decision_tree_board_full (self);
	}
	if (_tmp0_) {
		Player _tmp1_;
		_tmp1_ = self->priv->last_moving_player;
		if (_tmp1_ == PLAYER_HUMAN) {
			result = decision_tree_heurist (self);
			return result;
		} else {
			Player _tmp2_;
			_tmp2_ = self->priv->last_moving_player;
			if (_tmp2_ == PLAYER_AI) {
				result = -1 * decision_tree_heurist (self);
				return result;
			} else {
				result = 0;
				return result;
			}
		}
	}
	max = NEG_INF;
	next = -1;
	{
		gint column = 0;
		column = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_ = 0;
				gint temp = 0;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = column;
					column = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				if (!(column < BOARD_COLUMNS)) {
					break;
				}
				if (!decision_tree_move (self, column)) {
					continue;
				}
				if (decision_tree_victory (self, column)) {
					_tmp5_ = MAX_HEURIST_VALUE * height;
				} else {
					_tmp5_ = -1 * decision_tree_negamax (self, height - 1, -1 * beta, -1 * alpha);
				}
				temp = _tmp5_;
				decision_tree_unmove (self, column);
				if (temp > max) {
					next = column;
					max = temp;
				}
				if (temp > alpha) {
					alpha = temp;
				}
				if (alpha >= beta) {
					break;
				}
			}
		}
	}
	if (height == self->priv->plies) {
		self->priv->next_move_in_column = next;
	}
	result = max;
	return result;
}

static gboolean
decision_tree_victory (DecisionTree* self,
                       gint column)
{
	gint row = 0;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gboolean _tmp0_ = FALSE;
		row = 0;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp2_ = FALSE;
			if (!_tmp0_) {
				gint _tmp1_;
				_tmp1_ = row;
				row = _tmp1_ + 1;
			}
			_tmp0_ = FALSE;
			if (row < BOARD_ROWS) {
				Player* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				Player _tmp4_;
				_tmp3_ = self->priv->board;
				_tmp3__length1 = self->priv->board_length1;
				_tmp3__length2 = self->priv->board_length2;
				_tmp4_ = _tmp3_[(row * _tmp3__length2) + column];
				_tmp2_ = _tmp4_ == PLAYER_NONE;
			} else {
				_tmp2_ = FALSE;
			}
			if (!_tmp2_) {
				break;
			}
		}
	}
	if (decision_tree_vertical_win (self, row, column)) {
		_tmp7_ = TRUE;
	} else {
		_tmp7_ = decision_tree_horizontal_win (self, row, column);
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		_tmp6_ = decision_tree_forward_diagonal_win (self, row, column);
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = decision_tree_backward_diagonal_win (self, row, column);
	}
	result = _tmp5_;
	return result;
}

static gboolean
decision_tree_forward_diagonal_win (DecisionTree* self,
                                    gint i,
                                    gint j)
{
	gint count = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	count = 0;
	{
		gint k = 0;
		gint l = 0;
		k = i;
		l = j;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_;
					gint _tmp2_;
					gint _tmp3_;
					_tmp1_ = k;
					k = _tmp1_ - 1;
					_tmp2_ = l;
					l = _tmp2_ + 1;
					_tmp3_ = count;
					count = _tmp3_ + 1;
				}
				_tmp0_ = FALSE;
				if (k >= 0) {
					_tmp5_ = l < BOARD_COLUMNS;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					Player* _tmp6_;
					gint _tmp6__length1;
					gint _tmp6__length2;
					Player _tmp7_;
					Player _tmp8_;
					_tmp6_ = self->priv->board;
					_tmp6__length1 = self->priv->board_length1;
					_tmp6__length2 = self->priv->board_length2;
					_tmp7_ = _tmp6_[(k * _tmp6__length2) + l];
					_tmp8_ = self->priv->last_moving_player;
					_tmp4_ = _tmp7_ == _tmp8_;
				} else {
					_tmp4_ = FALSE;
				}
				if (!_tmp4_) {
					break;
				}
			}
		}
	}
	{
		gint k = 0;
		gint l = 0;
		k = i + 1;
		l = j - 1;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
				if (!_tmp9_) {
					gint _tmp10_;
					gint _tmp11_;
					gint _tmp12_;
					_tmp10_ = k;
					k = _tmp10_ + 1;
					_tmp11_ = l;
					l = _tmp11_ - 1;
					_tmp12_ = count;
					count = _tmp12_ + 1;
				}
				_tmp9_ = FALSE;
				if (k < BOARD_ROWS) {
					_tmp14_ = l >= 0;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					Player* _tmp15_;
					gint _tmp15__length1;
					gint _tmp15__length2;
					Player _tmp16_;
					Player _tmp17_;
					_tmp15_ = self->priv->board;
					_tmp15__length1 = self->priv->board_length1;
					_tmp15__length2 = self->priv->board_length2;
					_tmp16_ = _tmp15_[(k * _tmp15__length2) + l];
					_tmp17_ = self->priv->last_moving_player;
					_tmp13_ = _tmp16_ == _tmp17_;
				} else {
					_tmp13_ = FALSE;
				}
				if (!_tmp13_) {
					break;
				}
			}
		}
	}
	result = count >= 4;
	return result;
}

static gboolean
decision_tree_backward_diagonal_win (DecisionTree* self,
                                     gint i,
                                     gint j)
{
	gint count = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	count = 0;
	{
		gint k = 0;
		gint l = 0;
		k = i;
		l = j;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp4_ = FALSE;
				gboolean _tmp5_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_;
					gint _tmp2_;
					gint _tmp3_;
					_tmp1_ = k;
					k = _tmp1_ - 1;
					_tmp2_ = l;
					l = _tmp2_ - 1;
					_tmp3_ = count;
					count = _tmp3_ + 1;
				}
				_tmp0_ = FALSE;
				if (k >= 0) {
					_tmp5_ = l >= 0;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					Player* _tmp6_;
					gint _tmp6__length1;
					gint _tmp6__length2;
					Player _tmp7_;
					Player _tmp8_;
					_tmp6_ = self->priv->board;
					_tmp6__length1 = self->priv->board_length1;
					_tmp6__length2 = self->priv->board_length2;
					_tmp7_ = _tmp6_[(k * _tmp6__length2) + l];
					_tmp8_ = self->priv->last_moving_player;
					_tmp4_ = _tmp7_ == _tmp8_;
				} else {
					_tmp4_ = FALSE;
				}
				if (!_tmp4_) {
					break;
				}
			}
		}
	}
	{
		gint k = 0;
		gint l = 0;
		k = i + 1;
		l = j + 1;
		{
			gboolean _tmp9_ = FALSE;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
				if (!_tmp9_) {
					gint _tmp10_;
					gint _tmp11_;
					gint _tmp12_;
					_tmp10_ = k;
					k = _tmp10_ + 1;
					_tmp11_ = l;
					l = _tmp11_ + 1;
					_tmp12_ = count;
					count = _tmp12_ + 1;
				}
				_tmp9_ = FALSE;
				if (k < BOARD_ROWS) {
					_tmp14_ = l < BOARD_COLUMNS;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					Player* _tmp15_;
					gint _tmp15__length1;
					gint _tmp15__length2;
					Player _tmp16_;
					Player _tmp17_;
					_tmp15_ = self->priv->board;
					_tmp15__length1 = self->priv->board_length1;
					_tmp15__length2 = self->priv->board_length2;
					_tmp16_ = _tmp15_[(k * _tmp15__length2) + l];
					_tmp17_ = self->priv->last_moving_player;
					_tmp13_ = _tmp16_ == _tmp17_;
				} else {
					_tmp13_ = FALSE;
				}
				if (!_tmp13_) {
					break;
				}
			}
		}
	}
	result = count >= 4;
	return result;
}

static gboolean
decision_tree_horizontal_win (DecisionTree* self,
                              gint i,
                              gint j)
{
	gint count = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	count = 0;
	{
		gint k = 0;
		k = j;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp3_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_;
					gint _tmp2_;
					_tmp1_ = k;
					k = _tmp1_ - 1;
					_tmp2_ = count;
					count = _tmp2_ + 1;
				}
				_tmp0_ = FALSE;
				if (k >= 0) {
					Player* _tmp4_;
					gint _tmp4__length1;
					gint _tmp4__length2;
					Player _tmp5_;
					Player _tmp6_;
					_tmp4_ = self->priv->board;
					_tmp4__length1 = self->priv->board_length1;
					_tmp4__length2 = self->priv->board_length2;
					_tmp5_ = _tmp4_[(i * _tmp4__length2) + k];
					_tmp6_ = self->priv->last_moving_player;
					_tmp3_ = _tmp5_ == _tmp6_;
				} else {
					_tmp3_ = FALSE;
				}
				if (!_tmp3_) {
					break;
				}
			}
		}
	}
	{
		gint k = 0;
		k = j + 1;
		{
			gboolean _tmp7_ = FALSE;
			_tmp7_ = TRUE;
			while (TRUE) {
				gboolean _tmp10_ = FALSE;
				if (!_tmp7_) {
					gint _tmp8_;
					gint _tmp9_;
					_tmp8_ = k;
					k = _tmp8_ + 1;
					_tmp9_ = count;
					count = _tmp9_ + 1;
				}
				_tmp7_ = FALSE;
				if (k < BOARD_COLUMNS) {
					Player* _tmp11_;
					gint _tmp11__length1;
					gint _tmp11__length2;
					Player _tmp12_;
					Player _tmp13_;
					_tmp11_ = self->priv->board;
					_tmp11__length1 = self->priv->board_length1;
					_tmp11__length2 = self->priv->board_length2;
					_tmp12_ = _tmp11_[(i * _tmp11__length2) + k];
					_tmp13_ = self->priv->last_moving_player;
					_tmp10_ = _tmp12_ == _tmp13_;
				} else {
					_tmp10_ = FALSE;
				}
				if (!_tmp10_) {
					break;
				}
			}
		}
	}
	result = count >= 4;
	return result;
}

static gboolean
decision_tree_vertical_win (DecisionTree* self,
                            gint i,
                            gint j)
{
	gint count = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	count = 0;
	{
		gint k = 0;
		k = i;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gboolean _tmp3_ = FALSE;
				if (!_tmp0_) {
					gint _tmp1_;
					gint _tmp2_;
					_tmp1_ = k;
					k = _tmp1_ + 1;
					_tmp2_ = count;
					count = _tmp2_ + 1;
				}
				_tmp0_ = FALSE;
				if (k < BOARD_ROWS) {
					Player* _tmp4_;
					gint _tmp4__length1;
					gint _tmp4__length2;
					Player _tmp5_;
					Player _tmp6_;
					_tmp4_ = self->priv->board;
					_tmp4__length1 = self->priv->board_length1;
					_tmp4__length2 = self->priv->board_length2;
					_tmp5_ = _tmp4_[(k * _tmp4__length2) + j];
					_tmp6_ = self->priv->last_moving_player;
					_tmp3_ = _tmp5_ == _tmp6_;
				} else {
					_tmp3_ = FALSE;
				}
				if (!_tmp3_) {
					break;
				}
			}
		}
	}
	result = count >= 4;
	return result;
}

static gboolean
decision_tree_board_full (DecisionTree* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				Player* _tmp2_;
				gint _tmp2__length1;
				gint _tmp2__length2;
				Player _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < BOARD_COLUMNS)) {
					break;
				}
				_tmp2_ = self->priv->board;
				_tmp2__length1 = self->priv->board_length1;
				_tmp2__length2 = self->priv->board_length2;
				_tmp3_ = _tmp2_[(0 * _tmp2__length2) + i];
				if (_tmp3_ == PLAYER_NONE) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

static gboolean
decision_tree_move (DecisionTree* self,
                    gint column)
{
	gint row = 0;
	Player _tmp5_ = 0;
	Player _tmp6_;
	Player player = 0;
	Player* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Player _tmp8_;
	Player _tmp9_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gboolean _tmp0_ = FALSE;
		row = BOARD_ROWS - 1;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp2_ = FALSE;
			if (!_tmp0_) {
				gint _tmp1_;
				_tmp1_ = row;
				row = _tmp1_ - 1;
			}
			_tmp0_ = FALSE;
			if (row >= 0) {
				Player* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				Player _tmp4_;
				_tmp3_ = self->priv->board;
				_tmp3__length1 = self->priv->board_length1;
				_tmp3__length2 = self->priv->board_length2;
				_tmp4_ = _tmp3_[(row * _tmp3__length2) + column];
				_tmp2_ = _tmp4_ != PLAYER_NONE;
			} else {
				_tmp2_ = FALSE;
			}
			if (!_tmp2_) {
				break;
			}
		}
	}
	if (row < 0) {
		result = FALSE;
		return result;
	}
	_tmp6_ = self->priv->last_moving_player;
	if (_tmp6_ != PLAYER_AI) {
		_tmp5_ = PLAYER_AI;
	} else {
		_tmp5_ = PLAYER_HUMAN;
	}
	player = _tmp5_;
	_tmp7_ = self->priv->board;
	_tmp7__length1 = self->priv->board_length1;
	_tmp7__length2 = self->priv->board_length2;
	_tmp8_ = player;
	_tmp7_[(row * _tmp7__length2) + column] = _tmp8_;
	_tmp9_ = player;
	self->priv->last_moving_player = _tmp9_;
	result = TRUE;
	return result;
}

static void
decision_tree_unmove (DecisionTree* self,
                      gint column)
{
	Player _tmp0_;
	gint row = 0;
	Player* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	Player _tmp7_ = 0;
	Player _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->last_moving_player;
	_vala_return_if_fail (_tmp0_ != PLAYER_NONE, "last_moving_player != Player.NONE");
	{
		gboolean _tmp1_ = FALSE;
		row = 0;
		_tmp1_ = TRUE;
		while (TRUE) {
			gboolean _tmp3_ = FALSE;
			if (!_tmp1_) {
				gint _tmp2_;
				_tmp2_ = row;
				row = _tmp2_ + 1;
			}
			_tmp1_ = FALSE;
			if (row < BOARD_ROWS) {
				Player* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				Player _tmp5_;
				_tmp4_ = self->priv->board;
				_tmp4__length1 = self->priv->board_length1;
				_tmp4__length2 = self->priv->board_length2;
				_tmp5_ = _tmp4_[(row * _tmp4__length2) + column];
				_tmp3_ = _tmp5_ == PLAYER_NONE;
			} else {
				_tmp3_ = FALSE;
			}
			if (!_tmp3_) {
				break;
			}
		}
	}
	_tmp6_ = self->priv->board;
	_tmp6__length1 = self->priv->board_length1;
	_tmp6__length2 = self->priv->board_length2;
	_tmp6_[(row * _tmp6__length2) + column] = PLAYER_NONE;
	_tmp8_ = self->priv->last_moving_player;
	if (_tmp8_ == PLAYER_AI) {
		_tmp7_ = PLAYER_HUMAN;
	} else {
		_tmp7_ = PLAYER_AI;
	}
	self->priv->last_moving_player = _tmp7_;
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

void
decision_tree_update_board (DecisionTree* self,
                            const gchar* vstr)
{
	gint _tmp0_;
	gint _tmp1_;
	Player _tmp2_ = 0;
	gint _tmp3_;
	gint _tmp4_;
	Player move = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (vstr != NULL);
	self->priv->next_move_in_column = -1;
	_tmp0_ = strlen (vstr);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == 2) {
		return;
	}
	_tmp3_ = strlen (vstr);
	_tmp4_ = _tmp3_;
	if ((_tmp4_ % 2) == 0) {
		_tmp2_ = PLAYER_AI;
	} else {
		_tmp2_ = PLAYER_HUMAN;
	}
	move = _tmp2_;
	{
		gint i = 0;
		i = 1;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				gint _tmp8_;
				gint column = 0;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gint _tmp11_;
				gint row = 0;
				Player* _tmp17_;
				gint _tmp17__length1;
				gint _tmp17__length2;
				Player _tmp18_;
				Player _tmp19_ = 0;
				Player _tmp20_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = strlen (vstr);
				_tmp8_ = _tmp7_;
				if (!(i < (_tmp8_ - 1))) {
					break;
				}
				_tmp9_ = g_strdup_printf ("%c", string_get (vstr, (glong) i));
				_tmp10_ = _tmp9_;
				_tmp11_ = atoi (_tmp10_) - 1;
				_g_free0 (_tmp10_);
				column = _tmp11_;
				{
					gboolean _tmp12_ = FALSE;
					row = BOARD_ROWS - 1;
					_tmp12_ = TRUE;
					while (TRUE) {
						gboolean _tmp14_ = FALSE;
						if (!_tmp12_) {
							gint _tmp13_;
							_tmp13_ = row;
							row = _tmp13_ - 1;
						}
						_tmp12_ = FALSE;
						if (row >= 0) {
							Player* _tmp15_;
							gint _tmp15__length1;
							gint _tmp15__length2;
							Player _tmp16_;
							_tmp15_ = self->priv->board;
							_tmp15__length1 = self->priv->board_length1;
							_tmp15__length2 = self->priv->board_length2;
							_tmp16_ = _tmp15_[(row * _tmp15__length2) + column];
							_tmp14_ = _tmp16_ != PLAYER_NONE;
						} else {
							_tmp14_ = FALSE;
						}
						if (!_tmp14_) {
							break;
						}
					}
				}
				_tmp17_ = self->priv->board;
				_tmp17__length1 = self->priv->board_length1;
				_tmp17__length2 = self->priv->board_length2;
				_tmp18_ = move;
				_tmp17_[(row * _tmp17__length2) + column] = _tmp18_;
				_tmp20_ = move;
				if (_tmp20_ == PLAYER_HUMAN) {
					_tmp19_ = PLAYER_AI;
				} else {
					_tmp19_ = PLAYER_HUMAN;
				}
				move = _tmp19_;
			}
		}
	}
	self->priv->last_moving_player = PLAYER_HUMAN;
}

static gint
decision_tree_immediate_win (DecisionTree* self,
                             Player p)
{
	Player old_last_moving_player = 0;
	Player _tmp0_;
	Player _tmp1_ = 0;
	gboolean player_wins = FALSE;
	gint i = 0;
	Player _tmp4_;
	gint _tmp5_ = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->last_moving_player;
	old_last_moving_player = _tmp0_;
	if (p == PLAYER_AI) {
		_tmp1_ = PLAYER_HUMAN;
	} else {
		_tmp1_ = PLAYER_AI;
	}
	self->priv->last_moving_player = _tmp1_;
	player_wins = FALSE;
	{
		gboolean _tmp2_ = FALSE;
		i = 0;
		_tmp2_ = TRUE;
		while (TRUE) {
			if (!_tmp2_) {
				gint _tmp3_;
				_tmp3_ = i;
				i = _tmp3_ + 1;
			}
			_tmp2_ = FALSE;
			if (!(i < BOARD_COLUMNS)) {
				break;
			}
			if (!decision_tree_move (self, i)) {
				continue;
			}
			player_wins = decision_tree_victory (self, i);
			decision_tree_unmove (self, i);
			if (player_wins) {
				break;
			}
		}
	}
	_tmp4_ = old_last_moving_player;
	self->priv->last_moving_player = _tmp4_;
	if (player_wins) {
		_tmp5_ = i;
	} else {
		_tmp5_ = -1;
	}
	result = _tmp5_;
	return result;
}

gint
decision_tree_playgame (DecisionTree* self,
                        const gchar* vstr)
{
	gint temp = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (vstr != NULL, 0);
	decision_tree_set_level (self, vstr);
	decision_tree_update_board (self, vstr);
	temp = decision_tree_immediate_win (self, PLAYER_AI);
	if (temp != -1) {
		result = temp + 1;
		return result;
	}
	temp = decision_tree_immediate_win (self, PLAYER_HUMAN);
	if (temp != -1) {
		result = temp + 1;
		return result;
	}
	decision_tree_negamax (self, self->priv->plies, NEG_INF, -1 * NEG_INF);
	result = self->priv->next_move_in_column + 1;
	return result;
}

static gint
decision_tree_heurist (DecisionTree* self)
{
	Difficulty _tmp0_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->level;
	if (_tmp0_ == DIFFICULTY_EASY) {
		result = decision_tree_heurist_easy (self);
		return result;
	} else {
		Difficulty _tmp1_;
		_tmp1_ = self->priv->level;
		if (_tmp1_ == DIFFICULTY_MEDIUM) {
			result = decision_tree_heurist_medium (self);
			return result;
		} else {
			result = decision_tree_heurist_hard (self);
			return result;
		}
	}
}

static gint
decision_tree_heurist_easy (DecisionTree* self)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = -1 * decision_tree_heurist_hard (self);
	return result;
}

static gint
decision_tree_heurist_medium (DecisionTree* self)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) g_random_int_range ((gint32) 1, (gint32) 49);
	return result;
}

static gint
decision_tree_heurist_hard (DecisionTree* self)
{
	gint count = 0;
	gint32 _tmp0_ = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	count = decision_tree_count_3_in_a_row (self, PLAYER_AI) - decision_tree_count_3_in_a_row (self, PLAYER_HUMAN);
	if (count == 0) {
		_tmp0_ = g_random_int_range ((gint32) 1, (gint32) 49);
	} else {
		_tmp0_ = (gint32) (count * 100);
	}
	result = (gint) _tmp0_;
	return result;
}

static gint
decision_tree_count_3_in_a_row (DecisionTree* self,
                                Player p)
{
	gint count = 0;
	Player old_last_moving_player = 0;
	Player _tmp0_;
	Player _tmp10_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	count = 0;
	_tmp0_ = self->priv->last_moving_player;
	old_last_moving_player = _tmp0_;
	self->priv->last_moving_player = p;
	{
		gint j = 0;
		j = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = j;
					j = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(j < BOARD_COLUMNS)) {
					break;
				}
				{
					gint i = 0;
					i = 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							Player* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Player _tmp6_;
							Player* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							Player* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							if (!_tmp3_) {
								gint _tmp4_;
								_tmp4_ = i;
								i = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							if (!(i < BOARD_ROWS)) {
								break;
							}
							_tmp5_ = self->priv->board;
							_tmp5__length1 = self->priv->board_length1;
							_tmp5__length2 = self->priv->board_length2;
							_tmp6_ = _tmp5_[(i * _tmp5__length2) + j];
							if (_tmp6_ != PLAYER_NONE) {
								break;
							}
							if (decision_tree_all_adjacent_empty (self, i, j)) {
								continue;
							}
							_tmp7_ = self->priv->board;
							_tmp7__length1 = self->priv->board_length1;
							_tmp7__length2 = self->priv->board_length2;
							_tmp7_[(i * _tmp7__length2) + j] = p;
							if (decision_tree_victory (self, j)) {
								gint _tmp8_;
								_tmp8_ = count;
								count = _tmp8_ + 1;
							}
							_tmp9_ = self->priv->board;
							_tmp9__length1 = self->priv->board_length1;
							_tmp9__length2 = self->priv->board_length2;
							_tmp9_[(i * _tmp9__length2) + j] = PLAYER_NONE;
						}
					}
				}
			}
		}
	}
	_tmp10_ = old_last_moving_player;
	self->priv->last_moving_player = _tmp10_;
	result = count;
	return result;
}

static gboolean
decision_tree_all_adjacent_empty (DecisionTree* self,
                                  gint i,
                                  gint j)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	{
		gint k = 0;
		k = -1;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = k;
					k = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(k <= 1)) {
					break;
				}
				{
					gint l = 0;
					l = -1;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							gboolean _tmp4_ = FALSE;
							gboolean _tmp5_ = FALSE;
							gboolean _tmp6_ = FALSE;
							gboolean _tmp7_ = FALSE;
							gboolean _tmp8_ = FALSE;
							if (!_tmp2_) {
								gint _tmp3_;
								_tmp3_ = l;
								l = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(l <= 1)) {
								break;
							}
							if (k == 0) {
								_tmp4_ = l == 0;
							} else {
								_tmp4_ = FALSE;
							}
							if (_tmp4_) {
								continue;
							}
							if ((i + k) >= 0) {
								_tmp8_ = (i + k) < BOARD_ROWS;
							} else {
								_tmp8_ = FALSE;
							}
							if (_tmp8_) {
								_tmp7_ = (j + l) >= 0;
							} else {
								_tmp7_ = FALSE;
							}
							if (_tmp7_) {
								_tmp6_ = (j + l) < BOARD_COLUMNS;
							} else {
								_tmp6_ = FALSE;
							}
							if (_tmp6_) {
								Player* _tmp9_;
								gint _tmp9__length1;
								gint _tmp9__length2;
								Player _tmp10_;
								_tmp9_ = self->priv->board;
								_tmp9__length1 = self->priv->board_length1;
								_tmp9__length2 = self->priv->board_length2;
								_tmp10_ = _tmp9_[((i + k) * _tmp9__length2) + (j + l)];
								_tmp5_ = _tmp10_ != PLAYER_NONE;
							} else {
								_tmp5_ = FALSE;
							}
							if (_tmp5_) {
								result = FALSE;
								return result;
							}
						}
					}
				}
			}
		}
	}
	result = TRUE;
	return result;
}

static void
decision_tree_set_level (DecisionTree* self,
                         const gchar* vstr)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (vstr != NULL);
	if (string_get (vstr, (glong) 0) == 'a') {
		self->priv->level = DIFFICULTY_EASY;
		self->priv->plies = 4;
	} else {
		if (string_get (vstr, (glong) 0) == 'b') {
			self->priv->level = DIFFICULTY_MEDIUM;
			self->priv->plies = 7;
		} else {
			self->priv->level = DIFFICULTY_HARD;
			self->priv->plies = 7;
		}
	}
}

gint
decision_tree_playandcheck (DecisionTree* self,
                            const gchar* vstr)
{
	gint temp = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (vstr != NULL, 0);
	decision_tree_set_level (self, vstr);
	decision_tree_update_board (self, vstr);
	temp = decision_tree_immediate_win (self, PLAYER_AI);
	if (temp != -1) {
		result = 1000;
		return result;
	}
	temp = decision_tree_immediate_win (self, PLAYER_HUMAN);
	if (temp != -1) {
		result = temp + 1;
		return result;
	}
	decision_tree_negamax (self, self->priv->plies, NEG_INF, -1 * NEG_INF);
	result = self->priv->next_move_in_column + 1;
	return result;
}

static void
value_decision_tree_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_decision_tree_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		decision_tree_unref (value->data[0].v_pointer);
	}
}

static void
value_decision_tree_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = decision_tree_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_decision_tree_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_decision_tree_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		DecisionTree * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = decision_tree_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_decision_tree_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	DecisionTree ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = decision_tree_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_decision_tree (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecDecisionTree* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_DECISION_TREE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_decision_tree (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DECISION_TREE), NULL);
	return value->data[0].v_pointer;
}

void
value_set_decision_tree (GValue* value,
                         gpointer v_object)
{
	DecisionTree * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DECISION_TREE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DECISION_TREE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		decision_tree_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		decision_tree_unref (old);
	}
}

void
value_take_decision_tree (GValue* value,
                          gpointer v_object)
{
	DecisionTree * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_DECISION_TREE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_DECISION_TREE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		decision_tree_unref (old);
	}
}

static void
decision_tree_class_init (DecisionTreeClass * klass,
                          gpointer klass_data)
{
	decision_tree_parent_class = g_type_class_peek_parent (klass);
	((DecisionTreeClass *) klass)->finalize = decision_tree_finalize;
	g_type_class_adjust_private_offset (klass, &DecisionTree_private_offset);
}

static void
decision_tree_instance_init (DecisionTree * self,
                             gpointer klass)
{
	Player* _tmp0_;
	self->priv = decision_tree_get_instance_private (self);
	_tmp0_ = g_new0 (Player, BOARD_ROWS * BOARD_COLUMNS);
	self->priv->board = _tmp0_;
	self->priv->board_length1 = BOARD_ROWS;
	self->priv->board_length2 = BOARD_COLUMNS;
	self->priv->plies = 8;
	self->priv->last_moving_player = PLAYER_NONE;
	self->priv->next_move_in_column = -1;
	self->ref_count = 1;
}

static void
decision_tree_finalize (DecisionTree * obj)
{
	DecisionTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DECISION_TREE, DecisionTree);
	g_signal_handlers_destroy (self);
	self->priv->board = (g_free (self->priv->board), NULL);
}

GType
decision_tree_get_type (void)
{
	static volatile gsize decision_tree_type_id__volatile = 0;
	if (g_once_init_enter (&decision_tree_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_decision_tree_init, value_decision_tree_free_value, value_decision_tree_copy_value, value_decision_tree_peek_pointer, "p", value_decision_tree_collect_value, "p", value_decision_tree_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DecisionTreeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) decision_tree_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DecisionTree), 0, (GInstanceInitFunc) decision_tree_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType decision_tree_type_id;
		decision_tree_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DecisionTree", &g_define_type_info, &g_define_type_fundamental_info, 0);
		DecisionTree_private_offset = g_type_add_instance_private (decision_tree_type_id, sizeof (DecisionTreePrivate));
		g_once_init_leave (&decision_tree_type_id__volatile, decision_tree_type_id);
	}
	return decision_tree_type_id__volatile;
}

gpointer
decision_tree_ref (gpointer instance)
{
	DecisionTree * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
decision_tree_unref (gpointer instance)
{
	DecisionTree * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DECISION_TREE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

