/* game-board-view.c generated by valac 0.46.2, the Vala compiler
 * generated from game-board-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* game-board-view.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <glib/gi18n-lib.h>

#define TYPE_GAME_BOARD_VIEW (game_board_view_get_type ())
#define GAME_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_BOARD_VIEW, GameBoardView))
#define GAME_BOARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_BOARD_VIEW, GameBoardViewClass))
#define IS_GAME_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_BOARD_VIEW))
#define IS_GAME_BOARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_BOARD_VIEW))
#define GAME_BOARD_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_BOARD_VIEW, GameBoardViewClass))

typedef struct _GameBoardView GameBoardView;
typedef struct _GameBoardViewClass GameBoardViewClass;
typedef struct _GameBoardViewPrivate GameBoardViewPrivate;

#define TYPE_BOARD (board_get_type ())
#define BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD, Board))
#define BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD, BoardClass))
#define IS_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD))
#define IS_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD))
#define BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD, BoardClass))

typedef struct _Board Board;
typedef struct _BoardClass BoardClass;
enum  {
	GAME_BOARD_VIEW_0_PROPERTY,
	GAME_BOARD_VIEW_NUM_PROPERTIES
};
static GParamSpec* game_board_view_properties[GAME_BOARD_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_PREFS (prefs_get_type ())
#define PREFS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS, Prefs))
#define PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS, PrefsClass))
#define IS_PREFS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS))
#define IS_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS))
#define PREFS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS, PrefsClass))

typedef struct _Prefs Prefs;
typedef struct _PrefsClass PrefsClass;
typedef enum  {
	TILE_PLAYER1 = 0,
	TILE_PLAYER2,
	TILE_CLEAR,
	TILE_CLEAR_CURSOR,
	TILE_PLAYER1_CURSOR,
	TILE_PLAYER2_CURSOR
} Tile;

#define TYPE_TILE (tile_get_type ())

#define TYPE_THEME (theme_get_type ())
typedef struct _Theme Theme;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	GAME_BOARD_VIEW_COLUMN_CLICKED_SIGNAL,
	GAME_BOARD_VIEW_NUM_SIGNALS
};
static guint game_board_view_signals[GAME_BOARD_VIEW_NUM_SIGNALS] = {0};

struct _GameBoardView {
	GtkDrawingArea parent_instance;
	GameBoardViewPrivate * priv;
};

struct _GameBoardViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _GameBoardViewPrivate {
	gint boardsize;
	gint tilesize;
	gint offset[6];
	GdkPixbuf* pb_tileset_raw;
	GdkPixbuf* pb_bground_raw;
	GdkPixbuf* pb_tileset;
	GdkPixbuf* pb_bground;
	Board* game_board;
	gint board_x;
	gint board_y;
};

struct _Theme {
	gchar* title;
	gchar* fname_tileset;
	gchar* fname_bground;
	gchar* grid_color;
	gchar* player1;
	gchar* player2;
	gchar* player1_win;
	gchar* player2_win;
	gchar* player1_turn;
	gchar* player2_turn;
};

static gint GameBoardView_private_offset;
static gpointer game_board_view_parent_class = NULL;

GType game_board_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameBoardView, g_object_unref)
GType board_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Board, g_object_unref)
GameBoardView* game_board_view_new (Board* game_board);
GameBoardView* game_board_view_construct (GType object_type,
                                          Board* game_board);
GType prefs_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Prefs, g_object_unref)
Prefs* prefs_get_instance (void);
static void __lambda5_ (GameBoardView* self);
gboolean game_board_view_change_theme (GameBoardView* self);
static void ___lambda5__prefs_theme_changed (Prefs* _sender,
                                      gint theme_id,
                                      gpointer self);
gboolean game_board_view_load_pixmaps (GameBoardView* self);
static gint game_board_view_get_column (GameBoardView* self,
                                 gint xpos);
void game_board_view_draw_tile (GameBoardView* self,
                                gint r,
                                gint c);
static gboolean game_board_view_real_configure_event (GtkWidget* base,
                                               GdkEventConfigure* e);
GType tile_get_type (void) G_GNUC_CONST;
void game_board_view_refresh_pixmaps (GameBoardView* self);
static gboolean game_board_view_real_draw (GtkWidget* base,
                                    cairo_t* cr);
static void game_board_view_paint_tile (GameBoardView* self,
                                 cairo_t* cr,
                                 gint r,
                                 gint c);
static void game_board_view_draw_grid (GameBoardView* self,
                                cairo_t* cr);
GType theme_get_type (void) G_GNUC_CONST;
Theme* theme_dup (const Theme* self);
void theme_free (Theme* self);
void theme_copy (const Theme* self,
                 Theme* dest);
void theme_destroy (Theme* self);
gint prefs_get_theme_id (Prefs* self);
static void game_board_view_load_error (GameBoardView* self,
                                 const gchar* fname);
Tile board_get (Board* self,
                gint x,
                gint y);
void prefs_set_theme_id (Prefs* self,
                         gint value);
static gboolean game_board_view_real_button_press_event (GtkWidget* base,
                                                  GdkEventButton* e);
static void g_cclosure_user_marshal_BOOLEAN__INT (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data);
static void game_board_view_finalize (GObject * obj);

extern const Theme theme[5];

static inline gpointer
game_board_view_get_instance_private (GameBoardView* self)
{
	return G_STRUCT_MEMBER_P (self, GameBoardView_private_offset);
}

static void
__lambda5_ (GameBoardView* self)
{
	game_board_view_change_theme (self);
}

static void
___lambda5__prefs_theme_changed (Prefs* _sender,
                                 gint theme_id,
                                 gpointer self)
{
	__lambda5_ ((GameBoardView*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GameBoardView*
game_board_view_construct (GType object_type,
                           Board* game_board)
{
	GameBoardView * self = NULL;
	Prefs* _tmp0_;
	Prefs* _tmp1_;
	Board* _tmp2_;
	g_return_val_if_fail (game_board != NULL, NULL);
	self = (GameBoardView*) g_object_new (object_type, NULL);
	gtk_widget_set_size_request ((GtkWidget*) self, 350, 350);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
	gtk_widget_set_events ((GtkWidget*) self, (GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK);
	_tmp0_ = prefs_get_instance ();
	_tmp1_ = _tmp0_;
	g_signal_connect_object (_tmp1_, "theme-changed", (GCallback) ___lambda5__prefs_theme_changed, self, 0);
	game_board_view_load_pixmaps (self);
	_tmp2_ = _g_object_ref0 (game_board);
	_g_object_unref0 (self->priv->game_board);
	self->priv->game_board = _tmp2_;
	return self;
}

GameBoardView*
game_board_view_new (Board* game_board)
{
	return game_board_view_construct (TYPE_GAME_BOARD_VIEW, game_board);
}

static gint
game_board_view_get_column (GameBoardView* self,
                            gint xpos)
{
	gint c = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	c = xpos / self->priv->tilesize;
	if (c > 6) {
		c = 6;
	}
	if (c < 0) {
		c = 0;
	}
	result = c;
	return result;
}

void
game_board_view_draw_tile (GameBoardView* self,
                           gint r,
                           gint c)
{
	g_return_if_fail (self != NULL);
	gtk_widget_queue_draw_area ((GtkWidget*) self, (c * self->priv->tilesize) + self->priv->board_x, (r * self->priv->tilesize) + self->priv->board_y, self->priv->tilesize, self->priv->tilesize);
}

static gboolean
game_board_view_real_configure_event (GtkWidget* base,
                                      GdkEventConfigure* e)
{
	GameBoardView * self;
	gint allocated_width = 0;
	gint allocated_height = 0;
	gint size = 0;
	gboolean result = FALSE;
	self = (GameBoardView*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	allocated_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	allocated_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	size = MIN (allocated_width, allocated_height);
	self->priv->tilesize = size / 7;
	self->priv->boardsize = self->priv->tilesize * 7;
	self->priv->board_x = (allocated_width - self->priv->boardsize) / 2;
	self->priv->board_y = (allocated_height - self->priv->boardsize) / 2;
	self->priv->offset[TILE_PLAYER1] = 0;
	self->priv->offset[TILE_PLAYER2] = self->priv->tilesize;
	self->priv->offset[TILE_CLEAR] = self->priv->tilesize * 2;
	self->priv->offset[TILE_CLEAR_CURSOR] = self->priv->tilesize * 3;
	self->priv->offset[TILE_PLAYER1_CURSOR] = self->priv->tilesize * 4;
	self->priv->offset[TILE_PLAYER2_CURSOR] = self->priv->tilesize * 5;
	game_board_view_refresh_pixmaps (self);
	gtk_widget_queue_draw ((GtkWidget*) self);
	result = TRUE;
	return result;
}

gboolean
game_board_view_change_theme (GameBoardView* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (!game_board_view_load_pixmaps (self)) {
		result = FALSE;
		return result;
	}
	game_board_view_refresh_pixmaps (self);
	gtk_widget_queue_draw ((GtkWidget*) self);
	result = TRUE;
	return result;
}

static gboolean
game_board_view_real_draw (GtkWidget* base,
                           cairo_t* cr)
{
	GameBoardView * self;
	gint r = 0;
	gint c = 0;
	GdkPixbuf* _tmp0_;
	gboolean result = FALSE;
	self = (GameBoardView*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	cairo_save (cr);
	cairo_translate (cr, (gdouble) self->priv->board_x, (gdouble) self->priv->board_y);
	_tmp0_ = self->priv->pb_bground;
	gdk_cairo_set_source_pixbuf (cr, _tmp0_, (gdouble) 0, (gdouble) 0);
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, (gdouble) self->priv->boardsize, (gdouble) self->priv->boardsize);
	cairo_paint (cr);
	cairo_restore (cr);
	{
		gboolean _tmp1_ = FALSE;
		r = 0;
		_tmp1_ = TRUE;
		while (TRUE) {
			if (!_tmp1_) {
				gint _tmp2_;
				_tmp2_ = r;
				r = _tmp2_ + 1;
			}
			_tmp1_ = FALSE;
			if (!(r < 7)) {
				break;
			}
			{
				gboolean _tmp3_ = FALSE;
				c = 0;
				_tmp3_ = TRUE;
				while (TRUE) {
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = c;
						c = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					if (!(c < 7)) {
						break;
					}
					game_board_view_paint_tile (self, cr, r, c);
				}
			}
		}
	}
	cairo_save (cr);
	cairo_translate (cr, (gdouble) self->priv->board_x, (gdouble) self->priv->board_y);
	game_board_view_draw_grid (self, cr);
	cairo_restore (cr);
	result = FALSE;
	return result;
}

static void
game_board_view_draw_grid (GameBoardView* self,
                           cairo_t* cr)
{
	static const gdouble dashes[2] = {4.0, 4.0};
	gint i = 0;
	GdkRGBA color = {0};
	Prefs* _tmp0_;
	Prefs* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Theme _tmp4_;
	const gchar* _tmp5_;
	GdkRGBA _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	memset (&color, 0, sizeof (GdkRGBA));
	_tmp0_ = prefs_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = prefs_get_theme_id (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = theme[_tmp3_];
	_tmp5_ = _tmp4_.grid_color;
	gdk_rgba_parse (&color, _tmp5_);
	_tmp6_ = color;
	gdk_cairo_set_source_rgba (cr, &_tmp6_);
	cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
	cairo_set_line_width (cr, (gdouble) 1);
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_BUTT);
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_MITER);
	cairo_set_dash (cr, dashes, (gint) G_N_ELEMENTS (dashes), (gdouble) 0);
	{
		gboolean _tmp7_ = FALSE;
		i = 1;
		_tmp7_ = TRUE;
		while (TRUE) {
			if (!_tmp7_) {
				gint _tmp8_;
				_tmp8_ = i;
				i = _tmp8_ + 1;
			}
			_tmp7_ = FALSE;
			if (!(i < 7)) {
				break;
			}
			cairo_move_to (cr, (i * self->priv->tilesize) + 0.5, (gdouble) 0);
			cairo_line_to (cr, (i * self->priv->tilesize) + 0.5, (gdouble) self->priv->boardsize);
			cairo_move_to (cr, (gdouble) 0, (i * self->priv->tilesize) + 0.5);
			cairo_line_to (cr, (gdouble) self->priv->boardsize, (i * self->priv->tilesize) + 0.5);
		}
	}
	cairo_stroke (cr);
	cairo_set_dash (cr, NULL, (gint) 0, (gdouble) 0);
	cairo_move_to (cr, (gdouble) 0, self->priv->tilesize + 0.5);
	cairo_line_to (cr, (gdouble) self->priv->boardsize, self->priv->tilesize + 0.5);
	cairo_stroke (cr);
}

static void
game_board_view_load_error (GameBoardView* self,
                            const gchar* fname)
{
	GtkMessageDialog* dialog = NULL;
	GdkWindow* _tmp0_;
	GtkMessageDialog* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (fname != NULL);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp1_ = (GtkMessageDialog*) gtk_message_dialog_new (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, g_dgettext (GETTEXT_PACKAGE, "Unable to load image:\n%s"), fname);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (dialog);
	dialog = _tmp1_;
	gtk_dialog_run ((GtkDialog*) dialog);
	gtk_widget_destroy ((GtkWidget*) dialog);
	_g_object_unref0 (dialog);
}

static void
game_board_view_paint_tile (GameBoardView* self,
                            cairo_t* cr,
                            gint r,
                            gint c)
{
	gint x = 0;
	gint y = 0;
	gint tile = 0;
	Board* _tmp0_;
	gint os = 0;
	gboolean _tmp1_ = FALSE;
	GdkPixbuf* _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	x = (c * self->priv->tilesize) + self->priv->board_x;
	y = (r * self->priv->tilesize) + self->priv->board_y;
	_tmp0_ = self->priv->game_board;
	tile = (gint) board_get (_tmp0_, r, c);
	os = 0;
	if (tile == ((gint) TILE_CLEAR)) {
		_tmp1_ = r != 0;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		return;
	}
	switch (tile) {
		case TILE_PLAYER1:
		{
			if (r == 0) {
				gint _tmp2_;
				_tmp2_ = self->priv->offset[TILE_PLAYER1_CURSOR];
				os = _tmp2_;
			} else {
				gint _tmp3_;
				_tmp3_ = self->priv->offset[TILE_PLAYER1];
				os = _tmp3_;
			}
			break;
		}
		case TILE_PLAYER2:
		{
			if (r == 0) {
				gint _tmp4_;
				_tmp4_ = self->priv->offset[TILE_PLAYER2_CURSOR];
				os = _tmp4_;
			} else {
				gint _tmp5_;
				_tmp5_ = self->priv->offset[TILE_PLAYER2];
				os = _tmp5_;
			}
			break;
		}
		case TILE_CLEAR:
		{
			if (r == 0) {
				gint _tmp6_;
				_tmp6_ = self->priv->offset[TILE_CLEAR_CURSOR];
				os = _tmp6_;
			} else {
				gint _tmp7_;
				_tmp7_ = self->priv->offset[TILE_CLEAR];
				os = _tmp7_;
			}
			break;
		}
		default:
		break;
	}
	cairo_save (cr);
	_tmp8_ = self->priv->pb_tileset;
	gdk_cairo_set_source_pixbuf (cr, _tmp8_, (gdouble) (x - os), (gdouble) y);
	cairo_rectangle (cr, (gdouble) x, (gdouble) y, (gdouble) self->priv->tilesize, (gdouble) self->priv->tilesize);
	cairo_clip (cr);
	cairo_paint (cr);
	cairo_restore (cr);
}

void
game_board_view_refresh_pixmaps (GameBoardView* self)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pb_tileset_raw;
	_tmp1_ = gdk_pixbuf_scale_simple (_tmp0_, self->priv->tilesize * 6, self->priv->tilesize, GDK_INTERP_BILINEAR);
	_g_object_unref0 (self->priv->pb_tileset);
	self->priv->pb_tileset = _tmp1_;
	_tmp2_ = self->priv->pb_bground_raw;
	_tmp3_ = gdk_pixbuf_scale_simple (_tmp2_, self->priv->boardsize, self->priv->boardsize, GDK_INTERP_BILINEAR);
	_g_object_unref0 (self->priv->pb_bground);
	self->priv->pb_bground = _tmp3_;
}

gboolean
game_board_view_load_pixmaps (GameBoardView* self)
{
	gchar* fname = NULL;
	GdkPixbuf* pb_tileset_tmp = NULL;
	GdkPixbuf* pb_bground_tmp = NULL;
	GdkPixbuf* _tmp19_;
	GdkPixbuf* _tmp20_;
	Prefs* _tmp21_;
	Prefs* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	Theme _tmp25_;
	const gchar* _tmp26_;
	GdkPixbuf* _tmp40_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	pb_bground_tmp = NULL;
	while (TRUE) {
		Prefs* _tmp0_;
		Prefs* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		Theme _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp0_ = prefs_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = prefs_get_theme_id (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = theme[_tmp3_];
		_tmp5_ = _tmp4_.fname_tileset;
		_tmp6_ = g_build_filename (DATA_DIRECTORY, _tmp5_, NULL, NULL);
		_g_free0 (fname);
		fname = _tmp6_;
		{
			GdkPixbuf* _tmp7_ = NULL;
			const gchar* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
			_tmp8_ = fname;
			_tmp9_ = gdk_pixbuf_new_from_file (_tmp8_, &_inner_error0_);
			_tmp7_ = _tmp9_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch5_g_error;
			}
			_tmp10_ = _tmp7_;
			_tmp7_ = NULL;
			_g_object_unref0 (pb_tileset_tmp);
			pb_tileset_tmp = _tmp10_;
			_g_object_unref0 (_tmp7_);
		}
		goto __finally5;
		__catch5_g_error:
		{
			GError* e = NULL;
			Prefs* _tmp11_;
			Prefs* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp11_ = prefs_get_instance ();
			_tmp12_ = _tmp11_;
			_tmp13_ = prefs_get_theme_id (_tmp12_);
			_tmp14_ = _tmp13_;
			if (_tmp14_ != 0) {
				Prefs* _tmp15_;
				Prefs* _tmp16_;
				_tmp15_ = prefs_get_instance ();
				_tmp16_ = _tmp15_;
				prefs_set_theme_id (_tmp16_, 0);
				_g_error_free0 (e);
				continue;
			} else {
				const gchar* _tmp17_;
				_tmp17_ = fname;
				game_board_view_load_error (self, _tmp17_);
				result = FALSE;
				_g_error_free0 (e);
				_g_object_unref0 (pb_bground_tmp);
				_g_object_unref0 (pb_tileset_tmp);
				_g_free0 (fname);
				return result;
			}
			_g_error_free0 (e);
		}
		__finally5:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp18_ = FALSE;
			_g_object_unref0 (pb_bground_tmp);
			_g_object_unref0 (pb_tileset_tmp);
			_g_free0 (fname);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp18_;
		}
		break;
	}
	_tmp19_ = pb_tileset_tmp;
	_tmp20_ = _g_object_ref0 (_tmp19_);
	_g_object_unref0 (self->priv->pb_tileset_raw);
	self->priv->pb_tileset_raw = _tmp20_;
	_tmp21_ = prefs_get_instance ();
	_tmp22_ = _tmp21_;
	_tmp23_ = prefs_get_theme_id (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = theme[_tmp24_];
	_tmp26_ = _tmp25_.fname_bground;
	if (_tmp26_ != NULL) {
		Prefs* _tmp27_;
		Prefs* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
		Theme _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
		_tmp27_ = prefs_get_instance ();
		_tmp28_ = _tmp27_;
		_tmp29_ = prefs_get_theme_id (_tmp28_);
		_tmp30_ = _tmp29_;
		_tmp31_ = theme[_tmp30_];
		_tmp32_ = _tmp31_.fname_bground;
		_tmp33_ = g_build_filename (DATA_DIRECTORY, _tmp32_, NULL, NULL);
		_g_free0 (fname);
		fname = _tmp33_;
		{
			GdkPixbuf* _tmp34_ = NULL;
			const gchar* _tmp35_;
			GdkPixbuf* _tmp36_;
			GdkPixbuf* _tmp37_;
			_tmp35_ = fname;
			_tmp36_ = gdk_pixbuf_new_from_file (_tmp35_, &_inner_error0_);
			_tmp34_ = _tmp36_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch6_g_error;
			}
			_tmp37_ = _tmp34_;
			_tmp34_ = NULL;
			_g_object_unref0 (pb_bground_tmp);
			pb_bground_tmp = _tmp37_;
			_g_object_unref0 (_tmp34_);
		}
		goto __finally6;
		__catch6_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp38_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp38_ = fname;
			game_board_view_load_error (self, _tmp38_);
			result = FALSE;
			_g_error_free0 (e);
			_g_object_unref0 (pb_bground_tmp);
			_g_object_unref0 (pb_tileset_tmp);
			_g_free0 (fname);
			return result;
		}
		__finally6:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp39_ = FALSE;
			_g_object_unref0 (pb_bground_tmp);
			_g_object_unref0 (pb_tileset_tmp);
			_g_free0 (fname);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp39_;
		}
	}
	_tmp40_ = pb_bground_tmp;
	if (_tmp40_ != NULL) {
		GdkPixbuf* _tmp41_;
		GdkPixbuf* _tmp42_;
		_tmp41_ = pb_bground_tmp;
		_tmp42_ = _g_object_ref0 (_tmp41_);
		_g_object_unref0 (self->priv->pb_bground_raw);
		self->priv->pb_bground_raw = _tmp42_;
	} else {
		gint tilesize_raw = 0;
		gint i = 0;
		gint j = 0;
		GdkPixbuf* _tmp43_;
		GdkPixbuf* _tmp44_;
		_tmp43_ = self->priv->pb_tileset_raw;
		tilesize_raw = gdk_pixbuf_get_height (_tmp43_);
		_tmp44_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, tilesize_raw * 7, tilesize_raw * 7);
		_g_object_unref0 (self->priv->pb_bground_raw);
		self->priv->pb_bground_raw = _tmp44_;
		{
			gboolean _tmp45_ = FALSE;
			i = 0;
			_tmp45_ = TRUE;
			while (TRUE) {
				GdkPixbuf* _tmp47_;
				GdkPixbuf* _tmp48_;
				if (!_tmp45_) {
					gint _tmp46_;
					_tmp46_ = i;
					i = _tmp46_ + 1;
				}
				_tmp45_ = FALSE;
				if (!(i < 7)) {
					break;
				}
				_tmp47_ = self->priv->pb_tileset_raw;
				_tmp48_ = self->priv->pb_bground_raw;
				gdk_pixbuf_copy_area (_tmp47_, tilesize_raw * 3, 0, tilesize_raw, tilesize_raw, _tmp48_, i * tilesize_raw, 0);
				{
					gboolean _tmp49_ = FALSE;
					j = 1;
					_tmp49_ = TRUE;
					while (TRUE) {
						GdkPixbuf* _tmp51_;
						GdkPixbuf* _tmp52_;
						if (!_tmp49_) {
							gint _tmp50_;
							_tmp50_ = j;
							j = _tmp50_ + 1;
						}
						_tmp49_ = FALSE;
						if (!(j < 7)) {
							break;
						}
						_tmp51_ = self->priv->pb_tileset_raw;
						_tmp52_ = self->priv->pb_bground_raw;
						gdk_pixbuf_copy_area (_tmp51_, tilesize_raw * 2, 0, tilesize_raw, tilesize_raw, _tmp52_, i * tilesize_raw, j * tilesize_raw);
					}
				}
			}
		}
	}
	result = TRUE;
	_g_object_unref0 (pb_bground_tmp);
	_g_object_unref0 (pb_tileset_tmp);
	_g_free0 (fname);
	return result;
}

static gboolean
game_board_view_real_button_press_event (GtkWidget* base,
                                         GdkEventButton* e)
{
	GameBoardView * self;
	gint x = 0;
	GdkWindow* _tmp0_;
	GdkDevice* _tmp1_;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	gboolean result = FALSE;
	self = (GameBoardView*) base;
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp1_ = e->device;
	gdk_window_get_device_position (_tmp0_, _tmp1_, &_tmp2_, NULL, NULL);
	x = _tmp2_;
	g_signal_emit (self, game_board_view_signals[GAME_BOARD_VIEW_COLUMN_CLICKED_SIGNAL], 0, game_board_view_get_column (self, x), &_tmp3_);
	result = _tmp3_;
	return result;
}

static void
g_cclosure_user_marshal_BOOLEAN__INT (GClosure * closure,
                                      GValue * return_value,
                                      guint n_param_values,
                                      const GValue * param_values,
                                      gpointer invocation_hint,
                                      gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__INT) (gpointer data1, gint arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
	g_return_if_fail (return_value != NULL);
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_BOOLEAN__INT) (marshal_data ? marshal_data : cc->callback);
	v_return = callback (data1, g_value_get_int (param_values + 1), data2);
	g_value_set_boolean (return_value, v_return);
}

static void
game_board_view_class_init (GameBoardViewClass * klass,
                            gpointer klass_data)
{
	game_board_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GameBoardView_private_offset);
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) game_board_view_real_configure_event;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) game_board_view_real_draw;
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) game_board_view_real_button_press_event;
	G_OBJECT_CLASS (klass)->finalize = game_board_view_finalize;
	/**
	     * column_clicked:
	     *
	     * emited when a column on the game board is clicked
	     *
	     * @column:
	     *
	     * Which column was clicked on
	     */
	game_board_view_signals[GAME_BOARD_VIEW_COLUMN_CLICKED_SIGNAL] = g_signal_new ("column-clicked", TYPE_GAME_BOARD_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__INT, G_TYPE_BOOLEAN, 1, G_TYPE_INT);
}

static void
game_board_view_instance_init (GameBoardView * self,
                               gpointer klass)
{
	self->priv = game_board_view_get_instance_private (self);
	self->priv->boardsize = 0;
	self->priv->tilesize = 0;
}

static void
game_board_view_finalize (GObject * obj)
{
	GameBoardView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_BOARD_VIEW, GameBoardView);
	_g_object_unref0 (self->priv->pb_tileset_raw);
	_g_object_unref0 (self->priv->pb_bground_raw);
	_g_object_unref0 (self->priv->pb_tileset);
	_g_object_unref0 (self->priv->pb_bground);
	_g_object_unref0 (self->priv->game_board);
	G_OBJECT_CLASS (game_board_view_parent_class)->finalize (obj);
}

GType
game_board_view_get_type (void)
{
	static volatile gsize game_board_view_type_id__volatile = 0;
	if (g_once_init_enter (&game_board_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameBoardViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_board_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameBoardView), 0, (GInstanceInitFunc) game_board_view_instance_init, NULL };
		GType game_board_view_type_id;
		game_board_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "GameBoardView", &g_define_type_info, 0);
		GameBoardView_private_offset = g_type_add_instance_private (game_board_view_type_id, sizeof (GameBoardViewPrivate));
		g_once_init_leave (&game_board_view_type_id__volatile, game_board_view_type_id);
	}
	return game_board_view_type_id__volatile;
}

