/* game-board.c generated by valac 0.46.2, the Vala compiler
 * generated from game-board.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* game_board.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>

#define TYPE_BOARD (board_get_type ())
#define BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD, Board))
#define BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD, BoardClass))
#define IS_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD))
#define IS_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD))
#define BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD, BoardClass))

typedef struct _Board Board;
typedef struct _BoardClass BoardClass;
typedef struct _BoardPrivate BoardPrivate;
enum  {
	BOARD_0_PROPERTY,
	BOARD_NUM_PROPERTIES
};
static GParamSpec* board_properties[BOARD_NUM_PROPERTIES];
typedef enum  {
	TILE_PLAYER1 = 0,
	TILE_PLAYER2,
	TILE_CLEAR,
	TILE_CLEAR_CURSOR,
	TILE_PLAYER1_CURSOR,
	TILE_PLAYER2_CURSOR
} Tile;

#define TYPE_TILE (tile_get_type ())

struct _Board {
	GObject parent_instance;
	BoardPrivate * priv;
};

struct _BoardClass {
	GObjectClass parent_class;
};

static gpointer board_parent_class = NULL;
static Tile* board_gboard;
static gint board_gboard_length1;
static gint board_gboard_length2;
static Tile* board_gboard = NULL;
static gint board_gboard_length1 = 0;
static gint board_gboard_length2 = 0;

GType board_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Board, g_object_unref)
GType tile_get_type (void) G_GNUC_CONST;
#define BOARD_BOARD_SIZE 7
Board* board_new (void);
Board* board_construct (GType object_type);
void board_set (Board* self,
                gint x,
                gint y,
                Tile tile);
Tile board_get (Board* self,
                gint x,
                gint y);
void board_clear (Board* self);
gint board_first_empty_row (Board* self,
                            gint c);
static gboolean board_is_hline_at (Board* self,
                            Tile p,
                            gint r,
                            gint c,
                            gint* r1,
                            gint* c1,
                            gint* r2,
                            gint* c2);
gboolean board_is_line_at (Board* self,
                           Tile p,
                           gint r,
                           gint c,
                           gint* r1,
                           gint* c1,
                           gint* r2,
                           gint* c2);
static gboolean board_is_vline_at (Board* self,
                            Tile p,
                            gint r,
                            gint c,
                            gint* r1,
                            gint* c1,
                            gint* r2,
                            gint* c2);
static gboolean board_is_dline1_at (Board* self,
                             Tile p,
                             gint r,
                             gint c,
                             gint* r1,
                             gint* c1,
                             gint* r2,
                             gint* c2);
static gboolean board_is_dline2_at (Board* self,
                             Tile p,
                             gint r,
                             gint c,
                             gint* r1,
                             gint* c1,
                             gint* r2,
                             gint* c2);
static void board_finalize (GObject * obj);

Board*
board_construct (GType object_type)
{
	Board * self = NULL;
	Tile* _tmp0_;
	self = (Board*) g_object_new (object_type, NULL);
	_tmp0_ = g_new0 (Tile, BOARD_BOARD_SIZE * BOARD_BOARD_SIZE);
	board_gboard = (g_free (board_gboard), NULL);
	board_gboard = _tmp0_;
	board_gboard_length1 = BOARD_BOARD_SIZE;
	board_gboard_length2 = BOARD_BOARD_SIZE;
	return self;
}

Board*
board_new (void)
{
	return board_construct (TYPE_BOARD);
}

void
board_set (Board* self,
           gint x,
           gint y,
           Tile tile)
{
	Tile* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	g_return_if_fail (self != NULL);
	_tmp0_ = board_gboard;
	_tmp0__length1 = board_gboard_length1;
	_tmp0__length2 = board_gboard_length2;
	_tmp0_[(x * _tmp0__length2) + y] = tile;
}

Tile
board_get (Board* self,
           gint x,
           gint y)
{
	Tile* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Tile _tmp1_;
	Tile result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = board_gboard;
	_tmp0__length1 = board_gboard_length1;
	_tmp0__length2 = board_gboard_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	result = _tmp1_;
	return result;
}

void
board_clear (Board* self)
{
	g_return_if_fail (self != NULL);
	{
		gint r = 0;
		r = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = r;
					r = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(r < BOARD_BOARD_SIZE)) {
					break;
				}
				{
					gint c = 0;
					c = 0;
					{
						gboolean _tmp2_ = FALSE;
						_tmp2_ = TRUE;
						while (TRUE) {
							Tile* _tmp4_;
							gint _tmp4__length1;
							gint _tmp4__length2;
							if (!_tmp2_) {
								gint _tmp3_;
								_tmp3_ = c;
								c = _tmp3_ + 1;
							}
							_tmp2_ = FALSE;
							if (!(c < BOARD_BOARD_SIZE)) {
								break;
							}
							_tmp4_ = board_gboard;
							_tmp4__length1 = board_gboard_length1;
							_tmp4__length2 = board_gboard_length2;
							_tmp4_[(r * _tmp4__length2) + c] = TILE_CLEAR;
						}
					}
				}
			}
		}
	}
}

gint
board_first_empty_row (Board* self,
                       gint c)
{
	gint r = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	r = 1;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gint _tmp3_;
		if (r < BOARD_BOARD_SIZE) {
			Tile* _tmp1_;
			gint _tmp1__length1;
			gint _tmp1__length2;
			Tile _tmp2_;
			_tmp1_ = board_gboard;
			_tmp1__length1 = board_gboard_length1;
			_tmp1__length2 = board_gboard_length2;
			_tmp2_ = _tmp1_[(r * _tmp1__length2) + c];
			_tmp0_ = _tmp2_ == TILE_CLEAR;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_tmp3_ = r;
		r = _tmp3_ + 1;
	}
	result = r - 1;
	return result;
}

static gboolean
board_is_hline_at (Board* self,
                   Tile p,
                   gint r,
                   gint c,
                   gint* r1,
                   gint* c1,
                   gint* r2,
                   gint* c2)
{
	gint _vala_r1 = 0;
	gint _vala_c1 = 0;
	gint _vala_r2 = 0;
	gint _vala_c2 = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_r1 = r;
	_vala_r2 = r;
	_vala_c1 = c;
	_vala_c2 = c;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		if (_vala_c1 > 0) {
			Tile* _tmp1_;
			gint _tmp1__length1;
			gint _tmp1__length2;
			Tile _tmp2_;
			_tmp1_ = board_gboard;
			_tmp1__length1 = board_gboard_length1;
			_tmp1__length2 = board_gboard_length2;
			_tmp2_ = _tmp1_[(r * _tmp1__length2) + (_vala_c1 - 1)];
			_tmp0_ = _tmp2_ == p;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_vala_c1 = _vala_c1 - 1;
	}
	while (TRUE) {
		gboolean _tmp3_ = FALSE;
		if (_vala_c2 < 6) {
			Tile* _tmp4_;
			gint _tmp4__length1;
			gint _tmp4__length2;
			Tile _tmp5_;
			_tmp4_ = board_gboard;
			_tmp4__length1 = board_gboard_length1;
			_tmp4__length2 = board_gboard_length2;
			_tmp5_ = _tmp4_[(r * _tmp4__length2) + (_vala_c2 + 1)];
			_tmp3_ = _tmp5_ == p;
		} else {
			_tmp3_ = FALSE;
		}
		if (!_tmp3_) {
			break;
		}
		_vala_c2 = _vala_c2 + 1;
	}
	if ((_vala_c2 - _vala_c1) >= 3) {
		result = TRUE;
		if (r1) {
			*r1 = _vala_r1;
		}
		if (c1) {
			*c1 = _vala_c1;
		}
		if (r2) {
			*r2 = _vala_r2;
		}
		if (c2) {
			*c2 = _vala_c2;
		}
		return result;
	}
	result = FALSE;
	if (r1) {
		*r1 = _vala_r1;
	}
	if (c1) {
		*c1 = _vala_c1;
	}
	if (r2) {
		*r2 = _vala_r2;
	}
	if (c2) {
		*c2 = _vala_c2;
	}
	return result;
}

gboolean
board_is_line_at (Board* self,
                  Tile p,
                  gint r,
                  gint c,
                  gint* r1,
                  gint* c1,
                  gint* r2,
                  gint* c2)
{
	gint _vala_r1 = 0;
	gint _vala_c1 = 0;
	gint _vala_r2 = 0;
	gint _vala_c2 = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp7_ = board_is_hline_at (self, p, r, c, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
	_vala_r1 = _tmp3_;
	_vala_c1 = _tmp4_;
	_vala_r2 = _tmp5_;
	_vala_c2 = _tmp6_;
	if (_tmp7_) {
		_tmp2_ = TRUE;
	} else {
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gboolean _tmp12_;
		_tmp12_ = board_is_vline_at (self, p, r, c, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
		_vala_r1 = _tmp8_;
		_vala_c1 = _tmp9_;
		_vala_r2 = _tmp10_;
		_vala_c2 = _tmp11_;
		_tmp2_ = _tmp12_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gint _tmp16_ = 0;
		gboolean _tmp17_;
		_tmp17_ = board_is_dline1_at (self, p, r, c, &_tmp13_, &_tmp14_, &_tmp15_, &_tmp16_);
		_vala_r1 = _tmp13_;
		_vala_c1 = _tmp14_;
		_vala_r2 = _tmp15_;
		_vala_c2 = _tmp16_;
		_tmp1_ = _tmp17_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp18_ = 0;
		gint _tmp19_ = 0;
		gint _tmp20_ = 0;
		gint _tmp21_ = 0;
		gboolean _tmp22_;
		_tmp22_ = board_is_dline2_at (self, p, r, c, &_tmp18_, &_tmp19_, &_tmp20_, &_tmp21_);
		_vala_r1 = _tmp18_;
		_vala_c1 = _tmp19_;
		_vala_r2 = _tmp20_;
		_vala_c2 = _tmp21_;
		_tmp0_ = _tmp22_;
	}
	result = _tmp0_;
	if (r1) {
		*r1 = _vala_r1;
	}
	if (c1) {
		*c1 = _vala_c1;
	}
	if (r2) {
		*r2 = _vala_r2;
	}
	if (c2) {
		*c2 = _vala_c2;
	}
	return result;
}

static gboolean
board_is_vline_at (Board* self,
                   Tile p,
                   gint r,
                   gint c,
                   gint* r1,
                   gint* c1,
                   gint* r2,
                   gint* c2)
{
	gint _vala_r1 = 0;
	gint _vala_c1 = 0;
	gint _vala_r2 = 0;
	gint _vala_c2 = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_r1 = r;
	_vala_r2 = r;
	_vala_c1 = c;
	_vala_c2 = c;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		if (_vala_r1 > 1) {
			_tmp0_ = board_get (self, _vala_r1 - 1, c) == p;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_vala_r1 = _vala_r1 - 1;
	}
	while (TRUE) {
		gboolean _tmp1_ = FALSE;
		if (_vala_r2 < 6) {
			_tmp1_ = board_get (self, _vala_r2 + 1, c) == p;
		} else {
			_tmp1_ = FALSE;
		}
		if (!_tmp1_) {
			break;
		}
		_vala_r2 = _vala_r2 + 1;
	}
	if ((_vala_r2 - _vala_r1) >= 3) {
		result = TRUE;
		if (r1) {
			*r1 = _vala_r1;
		}
		if (c1) {
			*c1 = _vala_c1;
		}
		if (r2) {
			*r2 = _vala_r2;
		}
		if (c2) {
			*c2 = _vala_c2;
		}
		return result;
	}
	result = FALSE;
	if (r1) {
		*r1 = _vala_r1;
	}
	if (c1) {
		*c1 = _vala_c1;
	}
	if (r2) {
		*r2 = _vala_r2;
	}
	if (c2) {
		*c2 = _vala_c2;
	}
	return result;
}

static gboolean
board_is_dline1_at (Board* self,
                    Tile p,
                    gint r,
                    gint c,
                    gint* r1,
                    gint* c1,
                    gint* r2,
                    gint* c2)
{
	gint _vala_r1 = 0;
	gint _vala_c1 = 0;
	gint _vala_r2 = 0;
	gint _vala_c2 = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_r1 = r;
	_vala_r2 = r;
	_vala_c1 = c;
	_vala_c2 = c;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		if (_vala_c1 > 0) {
			_tmp1_ = _vala_r1 > 1;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			_tmp0_ = board_get (self, _vala_r1 - 1, _vala_c1 - 1) == p;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_vala_r1 = _vala_r1 - 1;
		_vala_c1 = _vala_c1 - 1;
	}
	while (TRUE) {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		if (_vala_c2 < 6) {
			_tmp3_ = _vala_r2 < 6;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			_tmp2_ = board_get (self, _vala_r2 + 1, _vala_c2 + 1) == p;
		} else {
			_tmp2_ = FALSE;
		}
		if (!_tmp2_) {
			break;
		}
		_vala_r2 = _vala_r2 + 1;
		_vala_c2 = _vala_c2 + 1;
	}
	if ((_vala_r2 - _vala_r1) >= 3) {
		result = TRUE;
		if (r1) {
			*r1 = _vala_r1;
		}
		if (c1) {
			*c1 = _vala_c1;
		}
		if (r2) {
			*r2 = _vala_r2;
		}
		if (c2) {
			*c2 = _vala_c2;
		}
		return result;
	}
	result = FALSE;
	if (r1) {
		*r1 = _vala_r1;
	}
	if (c1) {
		*c1 = _vala_c1;
	}
	if (r2) {
		*r2 = _vala_r2;
	}
	if (c2) {
		*c2 = _vala_c2;
	}
	return result;
}

static gboolean
board_is_dline2_at (Board* self,
                    Tile p,
                    gint r,
                    gint c,
                    gint* r1,
                    gint* c1,
                    gint* r2,
                    gint* c2)
{
	gint _vala_r1 = 0;
	gint _vala_c1 = 0;
	gint _vala_r2 = 0;
	gint _vala_c2 = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_r1 = r;
	_vala_r2 = r;
	_vala_c1 = c;
	_vala_c2 = c;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		if (_vala_c1 < 6) {
			_tmp1_ = _vala_r1 > 1;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			_tmp0_ = board_get (self, _vala_r1 - 1, _vala_c1 + 1) == p;
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		_vala_r1 = _vala_r1 - 1;
		_vala_c1 = _vala_c1 + 1;
	}
	while (TRUE) {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		if (_vala_c2 > 0) {
			_tmp3_ = _vala_r2 < 6;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			_tmp2_ = board_get (self, _vala_r2 + 1, _vala_c2 - 1) == p;
		} else {
			_tmp2_ = FALSE;
		}
		if (!_tmp2_) {
			break;
		}
		_vala_r2 = _vala_r2 + 1;
		_vala_c2 = _vala_c2 - 1;
	}
	if ((_vala_r2 - _vala_r1) >= 3) {
		result = TRUE;
		if (r1) {
			*r1 = _vala_r1;
		}
		if (c1) {
			*c1 = _vala_c1;
		}
		if (r2) {
			*r2 = _vala_r2;
		}
		if (c2) {
			*c2 = _vala_c2;
		}
		return result;
	}
	result = FALSE;
	if (r1) {
		*r1 = _vala_r1;
	}
	if (c1) {
		*c1 = _vala_c1;
	}
	if (r2) {
		*r2 = _vala_r2;
	}
	if (c2) {
		*c2 = _vala_c2;
	}
	return result;
}

static void
board_class_init (BoardClass * klass,
                  gpointer klass_data)
{
	board_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = board_finalize;
}

static void
board_instance_init (Board * self,
                     gpointer klass)
{
}

static void
board_finalize (GObject * obj)
{
	Board * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOARD, Board);
	G_OBJECT_CLASS (board_parent_class)->finalize (obj);
}

GType
board_get_type (void)
{
	static volatile gsize board_type_id__volatile = 0;
	if (g_once_init_enter (&board_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BoardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) board_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Board), 0, (GInstanceInitFunc) board_instance_init, NULL };
		GType board_type_id;
		board_type_id = g_type_register_static (G_TYPE_OBJECT, "Board", &g_define_type_info, 0);
		g_once_init_leave (&board_type_id__volatile, board_type_id);
	}
	return board_type_id__volatile;
}

