/* games-controls-list.c generated by valac 0.46.2, the Vala compiler
 * generated from games-controls-list.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * games-controls.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Needed to force vala to include headers in the correct order.
 * See https://gitlab.gnome.org/GNOME/vala/issues/98
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <stdarg.h>

typedef enum  {
	COLUMNS_CONFKEY_COLUMN = 0,
	COLUMNS_LABEL_COLUMN,
	COLUMNS_KEYCODE_COLUMN,
	COLUMNS_KEYMODS_COLUMN,
	COLUMNS_DEFAULT_KEYCODE_COLUMN,
	COLUMNS_DEFAULT_KEYMODS_COLUMN,
	COLUMNS_N_COLUMNS
} Columns;

#define TYPE_COLUMNS (columns_get_type ())

#define TYPE_GAMES_CONTROLS_LIST (games_controls_list_get_type ())
#define GAMES_CONTROLS_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAMES_CONTROLS_LIST, GamesControlsList))
#define GAMES_CONTROLS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAMES_CONTROLS_LIST, GamesControlsListClass))
#define IS_GAMES_CONTROLS_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAMES_CONTROLS_LIST))
#define IS_GAMES_CONTROLS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAMES_CONTROLS_LIST))
#define GAMES_CONTROLS_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAMES_CONTROLS_LIST, GamesControlsListClass))

typedef struct _GamesControlsList GamesControlsList;
typedef struct _GamesControlsListClass GamesControlsListClass;
typedef struct _GamesControlsListPrivate GamesControlsListPrivate;
enum  {
	GAMES_CONTROLS_LIST_0_PROPERTY,
	GAMES_CONTROLS_LIST_NUM_PROPERTIES
};
static GParamSpec* games_controls_list_properties[GAMES_CONTROLS_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GamesControlsList {
	GtkScrolledWindow parent_instance;
	GamesControlsListPrivate * priv;
};

struct _GamesControlsListClass {
	GtkScrolledWindowClass parent_class;
};

struct _GamesControlsListPrivate {
	GtkTreeModel* model;
	GtkListStore* store;
	GtkTreeView* view;
	GSettings* settings;
	gulong notify_handler_id;
};

static gint GamesControlsList_private_offset;
static gpointer games_controls_list_parent_class = NULL;

#define games_controls_gettext_package GETTEXT_PACKAGE
GType columns_get_type (void) G_GNUC_CONST;
GType games_controls_list_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GamesControlsList, g_object_unref)
GamesControlsList* games_controls_list_new (GSettings* settings);
GamesControlsList* games_controls_list_construct (GType object_type,
                                                  GSettings* settings);
static void games_controls_list_settings_changed_cb (GamesControlsList* self,
                                              const gchar* key);
static void _games_controls_list_settings_changed_cb_g_settings_changed (GSettings* _sender,
                                                                  const gchar* key,
                                                                  gpointer self);
static void games_controls_list_accel_edited_cb (GamesControlsList* self,
                                          const gchar* path_string,
                                          guint keyval,
                                          GdkModifierType mask,
                                          guint hardware_keycode);
static void _games_controls_list_accel_edited_cb_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender,
                                                                                const gchar* path_string,
                                                                                guint accel_key,
                                                                                GdkModifierType accel_mods,
                                                                                guint hardware_keycode,
                                                                                gpointer self);
static void games_controls_list_accel_cleared_cb (GamesControlsList* self,
                                           const gchar* path_string);
static void _games_controls_list_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender,
                                                                                  const gchar* path_string,
                                                                                  gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static void games_controls_list_add_control (GamesControlsList* self,
                                      const gchar* conf_key,
                                      const gchar* label,
                                      guint default_keyval);
void games_controls_list_add_controls (GamesControlsList* self,
                                       const gchar* first_gconf_key,
                                       ...);
static void games_controls_list_finalize (GObject * obj);

GType
columns_get_type (void)
{
	static volatile gsize columns_type_id__volatile = 0;
	if (g_once_init_enter (&columns_type_id__volatile)) {
		static const GEnumValue values[] = {{COLUMNS_CONFKEY_COLUMN, "COLUMNS_CONFKEY_COLUMN", "confkey-column"}, {COLUMNS_LABEL_COLUMN, "COLUMNS_LABEL_COLUMN", "label-column"}, {COLUMNS_KEYCODE_COLUMN, "COLUMNS_KEYCODE_COLUMN", "keycode-column"}, {COLUMNS_KEYMODS_COLUMN, "COLUMNS_KEYMODS_COLUMN", "keymods-column"}, {COLUMNS_DEFAULT_KEYCODE_COLUMN, "COLUMNS_DEFAULT_KEYCODE_COLUMN", "default-keycode-column"}, {COLUMNS_DEFAULT_KEYMODS_COLUMN, "COLUMNS_DEFAULT_KEYMODS_COLUMN", "default-keymods-column"}, {COLUMNS_N_COLUMNS, "COLUMNS_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
		GType columns_type_id;
		columns_type_id = g_enum_register_static ("Columns", values);
		g_once_init_leave (&columns_type_id__volatile, columns_type_id);
	}
	return columns_type_id__volatile;
}

static inline gpointer
games_controls_list_get_instance_private (GamesControlsList* self)
{
	return G_STRUCT_MEMBER_P (self, GamesControlsList_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_games_controls_list_settings_changed_cb_g_settings_changed (GSettings* _sender,
                                                             const gchar* key,
                                                             gpointer self)
{
	games_controls_list_settings_changed_cb ((GamesControlsList*) self, key);
}

static void
_games_controls_list_accel_edited_cb_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender,
                                                                           const gchar* path_string,
                                                                           guint accel_key,
                                                                           GdkModifierType accel_mods,
                                                                           guint hardware_keycode,
                                                                           gpointer self)
{
	games_controls_list_accel_edited_cb ((GamesControlsList*) self, path_string, accel_key, accel_mods, hardware_keycode);
}

static void
_games_controls_list_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender,
                                                                             const gchar* path_string,
                                                                             gpointer self)
{
	games_controls_list_accel_cleared_cb ((GamesControlsList*) self, path_string);
}

GamesControlsList*
games_controls_list_construct (GType object_type,
                               GSettings* settings)
{
	GamesControlsList * self = NULL;
	GtkCellRenderer* label_renderer = NULL;
	GtkCellRendererAccel* key_renderer = NULL;
	GtkTreeViewColumn* column = NULL;
	GSettings* _tmp0_;
	gulong _tmp1_;
	GtkListStore* _tmp2_;
	GtkListStore* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeView* _tmp6_;
	GtkTreeView* _tmp7_;
	GtkTreeView* _tmp8_;
	GtkCellRendererText* _tmp9_;
	GtkTreeViewColumn* _tmp10_;
	GtkTreeView* _tmp11_;
	GtkTreeViewColumn* _tmp12_;
	GtkCellRendererAccel* _tmp13_;
	GtkTreeViewColumn* _tmp14_;
	GtkTreeView* _tmp15_;
	GtkTreeViewColumn* _tmp16_;
	GtkTreeView* _tmp17_;
	g_return_val_if_fail (settings != NULL, NULL);
	self = (GamesControlsList*) g_object_new (object_type, NULL);
	g_object_set ((GtkScrolledWindow*) self, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
	g_object_set ((GtkScrolledWindow*) self, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
	gtk_scrolled_window_set_shadow_type ((GtkScrolledWindow*) self, GTK_SHADOW_IN);
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = g_signal_connect_object (settings, "changed", (GCallback) _games_controls_list_settings_changed_cb_g_settings_changed, self, 0);
	self->priv->notify_handler_id = _tmp1_;
	_tmp2_ = gtk_list_store_new ((gint) COLUMNS_N_COLUMNS, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, G_TYPE_UINT, -1);
	_g_object_unref0 (self->priv->store);
	self->priv->store = _tmp2_;
	_tmp3_ = self->priv->store;
	_tmp4_ = _g_object_ref0 ((GtkTreeModel*) _tmp3_);
	_g_object_unref0 (self->priv->model);
	self->priv->model = _tmp4_;
	_tmp5_ = self->priv->model;
	_tmp6_ = (GtkTreeView*) gtk_tree_view_new_with_model (_tmp5_);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->view);
	self->priv->view = _tmp6_;
	_tmp7_ = self->priv->view;
	gtk_tree_view_set_headers_visible (_tmp7_, FALSE);
	_tmp8_ = self->priv->view;
	gtk_tree_view_set_enable_search (_tmp8_, FALSE);
	_tmp9_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (label_renderer);
	label_renderer = (GtkCellRenderer*) _tmp9_;
	_tmp10_ = gtk_tree_view_column_new_with_attributes ("Control", label_renderer, "text", COLUMNS_LABEL_COLUMN, NULL);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (column);
	column = _tmp10_;
	_tmp11_ = self->priv->view;
	_tmp12_ = column;
	gtk_tree_view_append_column (_tmp11_, _tmp12_);
	_tmp13_ = (GtkCellRendererAccel*) gtk_cell_renderer_accel_new ();
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (key_renderer);
	key_renderer = _tmp13_;
	g_object_set ((GtkCellRendererText*) key_renderer, "editable", TRUE, NULL);
	g_object_set (key_renderer, "accel-mode", GTK_CELL_RENDERER_ACCEL_MODE_OTHER, NULL);
	g_signal_connect_object (key_renderer, "accel-edited", (GCallback) _games_controls_list_accel_edited_cb_gtk_cell_renderer_accel_accel_edited, self, 0);
	g_signal_connect_object (key_renderer, "accel-cleared", (GCallback) _games_controls_list_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared, self, 0);
	_tmp14_ = gtk_tree_view_column_new_with_attributes ("Key", (GtkCellRenderer*) key_renderer, "accel-key", COLUMNS_KEYCODE_COLUMN, "accel-mods", COLUMNS_KEYMODS_COLUMN, NULL);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (column);
	column = _tmp14_;
	_tmp15_ = self->priv->view;
	_tmp16_ = column;
	gtk_tree_view_append_column (_tmp15_, _tmp16_);
	_tmp17_ = self->priv->view;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp17_);
	_g_object_unref0 (column);
	_g_object_unref0 (key_renderer);
	_g_object_unref0 (label_renderer);
	return self;
}

GamesControlsList*
games_controls_list_new (GSettings* settings)
{
	return games_controls_list_construct (TYPE_GAMES_CONTROLS_LIST, settings);
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static void
games_controls_list_accel_cleared_cb (GamesControlsList* self,
                                      const gchar* path_string)
{
	GtkTreePath* path = NULL;
	GtkTreeIter iter = {0};
	gchar* conf_key = NULL;
	gint default_keyval = 0;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreePath* _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GSettings* _tmp10_;
	const gchar* _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path_string != NULL);
	conf_key = NULL;
	default_keyval = 0;
	_tmp0_ = gtk_tree_path_new_from_string (path_string);
	__vala_GtkTreePath_free0 (path);
	path = _tmp0_;
	_tmp1_ = path;
	if (_tmp1_ == NULL) {
		_g_free0 (conf_key);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp2_ = self->priv->model;
	_tmp3_ = path;
	_tmp5_ = gtk_tree_model_get_iter (_tmp2_, &_tmp4_, _tmp3_);
	iter = _tmp4_;
	if (!_tmp5_) {
		_g_free0 (conf_key);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp6_ = self->priv->model;
	_tmp7_ = iter;
	_tmp8_ = conf_key;
	gtk_tree_model_get (_tmp6_, &_tmp7_, COLUMNS_CONFKEY_COLUMN, _tmp8_, COLUMNS_DEFAULT_KEYCODE_COLUMN, default_keyval, -1);
	_tmp9_ = conf_key;
	if (_tmp9_ == NULL) {
		_g_free0 (conf_key);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp10_ = self->priv->settings;
	_tmp11_ = conf_key;
	g_settings_set_int (_tmp10_, _tmp11_, default_keyval);
	_g_free0 (conf_key);
	__vala_GtkTreePath_free0 (path);
}

static void
games_controls_list_accel_edited_cb (GamesControlsList* self,
                                     const gchar* path_string,
                                     guint keyval,
                                     GdkModifierType mask,
                                     guint hardware_keycode)
{
	GtkTreePath* path = NULL;
	GtkTreeIter iter = {0};
	gchar* conf_key = NULL;
	gboolean valid = FALSE;
	gboolean unused_key = FALSE;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreeModel* _tmp2_;
	GtkTreePath* _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GtkTreeModel* _tmp10_;
	GtkTreeIter _tmp11_ = {0};
	gboolean _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path_string != NULL);
	conf_key = NULL;
	unused_key = TRUE;
	_tmp0_ = gtk_tree_path_new_from_string (path_string);
	__vala_GtkTreePath_free0 (path);
	path = _tmp0_;
	_tmp1_ = path;
	if (_tmp1_ == NULL) {
		_g_free0 (conf_key);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp2_ = self->priv->model;
	_tmp3_ = path;
	_tmp5_ = gtk_tree_model_get_iter (_tmp2_, &_tmp4_, _tmp3_);
	iter = _tmp4_;
	if (!_tmp5_) {
		_g_free0 (conf_key);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp6_ = self->priv->model;
	_tmp7_ = iter;
	_tmp8_ = conf_key;
	gtk_tree_model_get (_tmp6_, &_tmp7_, COLUMNS_CONFKEY_COLUMN, _tmp8_, -1);
	_tmp9_ = conf_key;
	if (_tmp9_ == NULL) {
		_g_free0 (conf_key);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp10_ = self->priv->model;
	_tmp12_ = gtk_tree_model_get_iter_first (_tmp10_, &_tmp11_);
	iter = _tmp11_;
	valid = _tmp12_;
	while (TRUE) {
		gchar* actual_conf_key = NULL;
		GtkTreeModel* _tmp13_;
		GtkTreeIter _tmp14_;
		const gchar* _tmp15_;
		GSettings* _tmp16_;
		const gchar* _tmp17_;
		GtkListStore* _tmp22_;
		gboolean _tmp23_;
		if (!valid) {
			break;
		}
		actual_conf_key = NULL;
		_tmp13_ = self->priv->model;
		_tmp14_ = iter;
		_tmp15_ = actual_conf_key;
		gtk_tree_model_get (_tmp13_, &_tmp14_, COLUMNS_CONFKEY_COLUMN, _tmp15_, -1);
		_tmp16_ = self->priv->settings;
		_tmp17_ = actual_conf_key;
		if (((guint) g_settings_get_int (_tmp16_, _tmp17_)) == keyval) {
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			unused_key = FALSE;
			_tmp18_ = conf_key;
			_tmp19_ = actual_conf_key;
			if (g_strcmp0 (_tmp18_, _tmp19_) == 0) {
				GtkMessageDialog* dialog = NULL;
				GtkMessageDialog* _tmp20_;
				GtkMessageDialog* _tmp21_;
				_tmp20_ = (GtkMessageDialog*) gtk_message_dialog_new_with_markup (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, "<span weight=\"bold\" size=\"larger\">%s</span>", _ ("This key is already in use."));
				g_object_ref_sink (_tmp20_);
				dialog = _tmp20_;
				_tmp21_ = dialog;
				gtk_dialog_run ((GtkDialog*) _tmp21_);
				_g_object_unref0 (dialog);
			}
			_g_free0 (actual_conf_key);
			break;
		}
		_tmp22_ = self->priv->store;
		_tmp23_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp22_, &iter);
		valid = _tmp23_;
		_g_free0 (actual_conf_key);
	}
	if (unused_key) {
		GSettings* _tmp24_;
		const gchar* _tmp25_;
		_tmp24_ = self->priv->settings;
		_tmp25_ = conf_key;
		g_settings_set_int (_tmp24_, _tmp25_, (gint) keyval);
	}
	_g_free0 (conf_key);
	__vala_GtkTreePath_free0 (path);
}

static void
games_controls_list_add_control (GamesControlsList* self,
                                 const gchar* conf_key,
                                 const gchar* label,
                                 guint default_keyval)
{
	GtkTreeIter iter = {0};
	guint keyval = 0U;
	GSettings* _tmp0_;
	GtkListStore* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (conf_key != NULL);
	if (label == NULL) {
		label = _ ("Unknown Command");
	}
	_tmp0_ = self->priv->settings;
	keyval = (guint) g_settings_get_int (_tmp0_, conf_key);
	_tmp1_ = self->priv->store;
	gtk_list_store_insert_with_values (_tmp1_, &_tmp2_, -1, COLUMNS_CONFKEY_COLUMN, conf_key, COLUMNS_LABEL_COLUMN, label, COLUMNS_KEYCODE_COLUMN, keyval, COLUMNS_KEYMODS_COLUMN, 0, COLUMNS_DEFAULT_KEYCODE_COLUMN, default_keyval, COLUMNS_DEFAULT_KEYMODS_COLUMN, 0, -1);
	iter = _tmp2_;
}

void
games_controls_list_add_controls (GamesControlsList* self,
                                  const gchar* first_gconf_key,
                                  ...)
{
	va_list args = {0};
	gchar* key = NULL;
	gchar* label = NULL;
	guint keyval = 0U;
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (first_gconf_key != NULL);
	va_start (args, first_gconf_key);
	_tmp0_ = g_strdup (first_gconf_key);
	_g_free0 (key);
	key = _tmp0_;
	while (TRUE) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp1_ = key;
		if (!(_tmp1_ != NULL)) {
			break;
		}
		_tmp2_ = va_arg (args, gchar*);
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (label);
		label = _tmp3_;
		keyval = va_arg (args, guint);
		_tmp4_ = key;
		_tmp5_ = label;
		games_controls_list_add_control (self, _tmp4_, _tmp5_, keyval);
		_tmp6_ = va_arg (args, gchar*);
		_tmp7_ = g_strdup (_tmp6_);
		_g_free0 (key);
		key = _tmp7_;
	}
	_g_free0 (label);
	_g_free0 (key);
	va_end (args);
}

static void
games_controls_list_settings_changed_cb (GamesControlsList* self,
                                         const gchar* key)
{
	GtkTreeIter iter = {0};
	gboolean valid = FALSE;
	GtkTreeModel* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->priv->model;
	_tmp2_ = gtk_tree_model_get_iter_first (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	valid = _tmp2_;
	while (TRUE) {
		gchar* conf_key = NULL;
		GtkTreeModel* _tmp3_;
		GtkTreeIter _tmp4_;
		gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		GtkListStore* _tmp13_;
		gboolean _tmp14_;
		if (!valid) {
			break;
		}
		_tmp3_ = self->priv->model;
		_tmp4_ = iter;
		gtk_tree_model_get (_tmp3_, &_tmp4_, COLUMNS_CONFKEY_COLUMN, &_tmp5_, -1);
		_g_free0 (conf_key);
		conf_key = _tmp5_;
		_tmp6_ = conf_key;
		if (g_strcmp0 (key, _tmp6_) == 0) {
			guint keyval = 0U;
			guint default_keyval = 0U;
			GtkTreeModel* _tmp7_;
			GtkTreeIter _tmp8_;
			guint _tmp9_ = 0U;
			GSettings* _tmp10_;
			GtkListStore* _tmp11_;
			GtkTreeIter _tmp12_;
			_tmp7_ = self->priv->model;
			_tmp8_ = iter;
			gtk_tree_model_get (_tmp7_, &_tmp8_, COLUMNS_DEFAULT_KEYCODE_COLUMN, &_tmp9_, -1);
			default_keyval = _tmp9_;
			_tmp10_ = self->priv->settings;
			keyval = (guint) g_settings_get_int (_tmp10_, key);
			_tmp11_ = self->priv->store;
			_tmp12_ = iter;
			gtk_list_store_set (_tmp11_, &_tmp12_, COLUMNS_KEYCODE_COLUMN, keyval, COLUMNS_KEYMODS_COLUMN, 0, -1);
			_g_free0 (conf_key);
			break;
		}
		_tmp13_ = self->priv->store;
		_tmp14_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp13_, &iter);
		valid = _tmp14_;
		_g_free0 (conf_key);
	}
}

static void
games_controls_list_class_init (GamesControlsListClass * klass,
                                gpointer klass_data)
{
	games_controls_list_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GamesControlsList_private_offset);
	G_OBJECT_CLASS (klass)->finalize = games_controls_list_finalize;
}

static void
games_controls_list_instance_init (GamesControlsList * self,
                                   gpointer klass)
{
	self->priv = games_controls_list_get_instance_private (self);
}

static void
games_controls_list_finalize (GObject * obj)
{
	GamesControlsList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAMES_CONTROLS_LIST, GamesControlsList);
	_g_object_unref0 (self->priv->model);
	_g_object_unref0 (self->priv->store);
	_g_object_unref0 (self->priv->view);
	_g_object_unref0 (self->priv->settings);
	G_OBJECT_CLASS (games_controls_list_parent_class)->finalize (obj);
}

GType
games_controls_list_get_type (void)
{
	static volatile gsize games_controls_list_type_id__volatile = 0;
	if (g_once_init_enter (&games_controls_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GamesControlsListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_controls_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesControlsList), 0, (GInstanceInitFunc) games_controls_list_instance_init, NULL };
		GType games_controls_list_type_id;
		games_controls_list_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "GamesControlsList", &g_define_type_info, 0);
		GamesControlsList_private_offset = g_type_add_instance_private (games_controls_list_type_id, sizeof (GamesControlsListPrivate));
		g_once_init_leave (&games_controls_list_type_id__volatile, games_controls_list_type_id);
	}
	return games_controls_list_type_id__volatile;
}

