/* prefs-box.c generated by valac 0.46.2, the Vala compiler
 * generated from prefs-box.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
* prefs-box.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define TYPE_PREFS_BOX (prefs_box_get_type ())
#define PREFS_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS_BOX, PrefsBox))
#define PREFS_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS_BOX, PrefsBoxClass))
#define IS_PREFS_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS_BOX))
#define IS_PREFS_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS_BOX))
#define PREFS_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS_BOX, PrefsBoxClass))

typedef struct _PrefsBox PrefsBox;
typedef struct _PrefsBoxClass PrefsBoxClass;
typedef struct _PrefsBoxPrivate PrefsBoxPrivate;
enum  {
	PREFS_BOX_0_PROPERTY,
	PREFS_BOX_NUM_PROPERTIES
};
static GParamSpec* prefs_box_properties[PREFS_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_GAMES_CONTROLS_LIST (games_controls_list_get_type ())
#define GAMES_CONTROLS_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAMES_CONTROLS_LIST, GamesControlsList))
#define GAMES_CONTROLS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAMES_CONTROLS_LIST, GamesControlsListClass))
#define IS_GAMES_CONTROLS_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAMES_CONTROLS_LIST))
#define IS_GAMES_CONTROLS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAMES_CONTROLS_LIST))
#define GAMES_CONTROLS_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAMES_CONTROLS_LIST, GamesControlsListClass))

typedef struct _GamesControlsList GamesControlsList;
typedef struct _GamesControlsListClass GamesControlsListClass;
typedef enum  {
	LEVEL_HUMAN,
	LEVEL_WEAK,
	LEVEL_MEDIUM,
	LEVEL_STRONG
} Level;

#define TYPE_LEVEL (level_get_type ())

#define TYPE_PREFS (prefs_get_type ())
#define PREFS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS, Prefs))
#define PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS, PrefsClass))
#define IS_PREFS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS))
#define IS_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS))
#define PREFS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS, PrefsClass))

typedef struct _Prefs Prefs;
typedef struct _PrefsClass PrefsClass;
typedef struct _PrefsPrivate PrefsPrivate;
typedef enum  {
	PLAYER_ID_PLAYER1 = 0,
	PLAYER_ID_PLAYER2,
	PLAYER_ID_NOBODY
} PlayerID;

#define TYPE_PLAYER_ID (player_id_get_type ())

#define TYPE_THEME (theme_get_type ())
typedef struct _Theme Theme;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_FOUR_IN_AROW (four_in_arow_get_type ())
#define FOUR_IN_AROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FOUR_IN_AROW, FourInARow))
#define FOUR_IN_AROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FOUR_IN_AROW, FourInARowClass))
#define IS_FOUR_IN_AROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FOUR_IN_AROW))
#define IS_FOUR_IN_AROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FOUR_IN_AROW))
#define FOUR_IN_AROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FOUR_IN_AROW, FourInARowClass))

typedef struct _FourInARow FourInARow;
typedef struct _FourInARowClass FourInARowClass;
typedef struct _FourInARowPrivate FourInARowPrivate;

struct _PrefsBox {
	GtkDialog parent_instance;
	PrefsBoxPrivate * priv;
};

struct _PrefsBoxClass {
	GtkDialogClass parent_class;
};

struct _PrefsBoxPrivate {
	GtkNotebook* notebook;
	GtkComboBox* combobox;
	GtkComboBoxText* combobox_theme;
	GtkToggleButton* checkbutton_sound;
};

struct _Prefs {
	GObject parent_instance;
	PrefsPrivate * priv;
	Level level[2];
	GSettings* settings;
};

struct _PrefsClass {
	GObjectClass parent_class;
};

struct _Theme {
	gchar* title;
	gchar* fname_tileset;
	gchar* fname_bground;
	gchar* grid_color;
	gchar* player1;
	gchar* player2;
	gchar* player1_win;
	gchar* player2_win;
	gchar* player1_turn;
	gchar* player2_turn;
};

struct _FourInARow {
	GtkApplication parent_instance;
	FourInARowPrivate * priv;
	gboolean gameover;
	gboolean player_active;
	PlayerID who_starts;
	gint score[3];
	gint column;
	gint column_moveto;
	guint timeout;
};

struct _FourInARowClass {
	GtkApplicationClass parent_class;
};

static gint PrefsBox_private_offset;
static gpointer prefs_box_parent_class = NULL;

GType prefs_box_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PrefsBox, g_object_unref)
PrefsBox* prefs_box_new (GtkWindow* parent);
PrefsBox* prefs_box_construct (GType object_type,
                               GtkWindow* parent);
GType games_controls_list_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GamesControlsList, g_object_unref)
GType level_get_type (void) G_GNUC_CONST;
GType prefs_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Prefs, g_object_unref)
Prefs* prefs_get_instance (void);
GType player_id_get_type (void) G_GNUC_CONST;
static void prefs_box_on_select_opponent (PrefsBox* self,
                                   GtkComboBox* w);
static void _prefs_box_on_select_opponent_gtk_combo_box_changed (GtkComboBox* _sender,
                                                          gpointer self);
GType theme_get_type (void) G_GNUC_CONST;
Theme* theme_dup (const Theme* self);
void theme_free (Theme* self);
void theme_copy (const Theme* self,
                 Theme* dest);
void theme_destroy (Theme* self);
gchar* theme_get_title (gint id);
GamesControlsList* games_controls_list_new (GSettings* settings);
GamesControlsList* games_controls_list_construct (GType object_type,
                                                  GSettings* settings);
void games_controls_list_add_controls (GamesControlsList* self,
                                       const gchar* first_gconf_key,
                                       ...);
#define DEFAULT_KEY_LEFT GDK_KEY_Left
#define DEFAULT_KEY_RIGHT GDK_KEY_Right
#define DEFAULT_KEY_DROP GDK_KEY_Down
gint prefs_get_theme_id (Prefs* self);
gboolean prefs_get_do_sound (Prefs* self);
static void prefs_box_on_select_theme (PrefsBox* self,
                                GtkComboBox* combo);
static void _prefs_box_on_select_theme_gtk_combo_box_changed (GtkComboBox* _sender,
                                                       gpointer self);
void prefs_on_toggle_sound (Prefs* self,
                            GtkToggleButton* t);
static void _prefs_on_toggle_sound_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                       gpointer self);
static void __lambda6_ (PrefsBox* self,
                 gint theme_id);
static void ___lambda6__prefs_theme_changed (Prefs* _sender,
                                      gint theme_id,
                                      gpointer self);
static void __lambda7_ (PrefsBox* self);
static void ___lambda7__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static gboolean prefs_box_real_delete_event (GtkWidget* base,
                                      GdkEventAny* event);
void prefs_set_theme_id (Prefs* self,
                         gint value);
GType four_in_arow_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FourInARow, g_object_unref)
void four_in_arow_game_reset (FourInARow* self);
static void prefs_box_finalize (GObject * obj);

extern const Theme theme[5];

static inline gpointer
prefs_box_get_instance_private (PrefsBox* self)
{
	return G_STRUCT_MEMBER_P (self, PrefsBox_private_offset);
}

static void
_prefs_box_on_select_opponent_gtk_combo_box_changed (GtkComboBox* _sender,
                                                     gpointer self)
{
	prefs_box_on_select_opponent ((PrefsBox*) self, _sender);
}

static void
_prefs_box_on_select_theme_gtk_combo_box_changed (GtkComboBox* _sender,
                                                  gpointer self)
{
	prefs_box_on_select_theme ((PrefsBox*) self, _sender);
}

static void
_prefs_on_toggle_sound_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                  gpointer self)
{
	prefs_on_toggle_sound ((Prefs*) self, _sender);
}

static void
__lambda6_ (PrefsBox* self,
            gint theme_id)
{
	GtkComboBoxText* _tmp0_;
	_tmp0_ = self->priv->combobox_theme;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp0_, theme_id);
}

static void
___lambda6__prefs_theme_changed (Prefs* _sender,
                                 gint theme_id,
                                 gpointer self)
{
	__lambda6_ ((PrefsBox*) self, theme_id);
}

static void
__lambda7_ (PrefsBox* self)
{
	GtkToggleButton* _tmp0_;
	Prefs* _tmp1_;
	Prefs* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	_tmp0_ = self->priv->checkbutton_sound;
	_tmp1_ = prefs_get_instance ();
	_tmp2_ = _tmp1_;
	_tmp3_ = prefs_get_do_sound (_tmp2_);
	_tmp4_ = _tmp3_;
	gtk_toggle_button_set_active (_tmp0_, _tmp4_);
}

static void
___lambda7__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda7_ ((PrefsBox*) self);
}

PrefsBox*
prefs_box_construct (GType object_type,
                     GtkWindow* parent)
{
	PrefsBox * self = NULL;
	GtkGrid* grid = NULL;
	GamesControlsList* controls_list = NULL;
	GtkLabel* label = NULL;
	GtkCellRendererText* renderer = NULL;
	GtkListStore* model = NULL;
	GtkTreeIter iter = {0};
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkBox* _tmp2_;
	GtkNotebook* _tmp3_;
	GtkNotebook* _tmp4_;
	GtkBox* _tmp5_;
	GtkNotebook* _tmp6_;
	GtkGrid* _tmp7_;
	GtkGrid* _tmp8_;
	GtkGrid* _tmp9_;
	GtkGrid* _tmp10_;
	GtkLabel* _tmp11_;
	GtkNotebook* _tmp12_;
	GtkGrid* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkGrid* _tmp19_;
	GtkLabel* _tmp20_;
	GtkComboBox* _tmp21_;
	GtkCellRendererText* _tmp22_;
	GtkComboBox* _tmp23_;
	GtkCellRendererText* _tmp24_;
	GtkComboBox* _tmp25_;
	GtkCellRendererText* _tmp26_;
	GtkListStore* _tmp27_;
	GtkComboBox* _tmp28_;
	GtkListStore* _tmp29_;
	GtkListStore* _tmp30_;
	GtkTreeIter _tmp31_ = {0};
	GtkListStore* _tmp32_;
	GtkTreeIter _tmp33_;
	Prefs* _tmp34_;
	Prefs* _tmp35_;
	Level _tmp36_;
	GtkListStore* _tmp39_;
	GtkTreeIter _tmp40_ = {0};
	GtkListStore* _tmp41_;
	GtkTreeIter _tmp42_;
	Prefs* _tmp43_;
	Prefs* _tmp44_;
	Level _tmp45_;
	GtkListStore* _tmp48_;
	GtkTreeIter _tmp49_ = {0};
	GtkListStore* _tmp50_;
	GtkTreeIter _tmp51_;
	Prefs* _tmp52_;
	Prefs* _tmp53_;
	Level _tmp54_;
	GtkListStore* _tmp57_;
	GtkTreeIter _tmp58_ = {0};
	GtkListStore* _tmp59_;
	GtkTreeIter _tmp60_;
	Prefs* _tmp61_;
	Prefs* _tmp62_;
	Level _tmp63_;
	GtkComboBox* _tmp66_;
	GtkGrid* _tmp67_;
	GtkComboBox* _tmp68_;
	GtkLabel* _tmp69_;
	GtkLabel* _tmp70_;
	GtkLabel* _tmp71_;
	GtkLabel* _tmp72_;
	GtkGrid* _tmp73_;
	GtkLabel* _tmp74_;
	GtkComboBoxText* _tmp75_;
	GtkLabel* _tmp81_;
	GtkComboBoxText* _tmp82_;
	GtkGrid* _tmp83_;
	GtkComboBoxText* _tmp84_;
	GtkCheckButton* _tmp85_;
	GtkGrid* _tmp86_;
	GtkToggleButton* _tmp87_;
	GtkLabel* _tmp88_;
	Prefs* _tmp89_;
	Prefs* _tmp90_;
	GSettings* _tmp91_;
	GamesControlsList* _tmp92_;
	GtkNotebook* _tmp93_;
	GtkLabel* _tmp94_;
	GtkComboBoxText* _tmp95_;
	Prefs* _tmp96_;
	Prefs* _tmp97_;
	gint _tmp98_;
	gint _tmp99_;
	GtkToggleButton* _tmp100_;
	Prefs* _tmp101_;
	Prefs* _tmp102_;
	gboolean _tmp103_;
	gboolean _tmp104_;
	GtkComboBoxText* _tmp105_;
	GtkToggleButton* _tmp106_;
	Prefs* _tmp107_;
	Prefs* _tmp108_;
	Prefs* _tmp109_;
	Prefs* _tmp110_;
	Prefs* _tmp111_;
	Prefs* _tmp112_;
	g_return_val_if_fail (parent != NULL, NULL);
	self = (PrefsBox*) g_object_new (object_type, "title", _ ("Preferences"), "destroy-with-parent", TRUE, NULL);
	gtk_window_set_transient_for ((GtkWindow*) self, parent);
	_tmp0_ = gtk_window_get_application (parent);
	_tmp1_ = _tmp0_;
	gtk_window_set_application ((GtkWindow*) self, _tmp1_);
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 5);
	_tmp2_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	gtk_box_set_spacing (_tmp2_, 2);
	_tmp3_ = (GtkNotebook*) gtk_notebook_new ();
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->notebook);
	self->priv->notebook = _tmp3_;
	_tmp4_ = self->priv->notebook;
	gtk_container_set_border_width ((GtkContainer*) _tmp4_, (guint) 5);
	_tmp5_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	_tmp6_ = self->priv->notebook;
	gtk_box_pack_start (_tmp5_, (GtkWidget*) _tmp6_, TRUE, TRUE, (guint) 0);
	_tmp7_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (grid);
	grid = _tmp7_;
	_tmp8_ = grid;
	gtk_grid_set_row_spacing (_tmp8_, (guint) 6);
	_tmp9_ = grid;
	gtk_grid_set_column_spacing (_tmp9_, (guint) 12);
	_tmp10_ = grid;
	gtk_container_set_border_width ((GtkContainer*) _tmp10_, (guint) 12);
	_tmp11_ = (GtkLabel*) gtk_label_new (_ ("Game"));
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (label);
	label = _tmp11_;
	_tmp12_ = self->priv->notebook;
	_tmp13_ = grid;
	_tmp14_ = label;
	gtk_notebook_append_page (_tmp12_, (GtkWidget*) _tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = (GtkLabel*) gtk_label_new (_ ("Opponent:"));
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (label);
	label = _tmp15_;
	_tmp16_ = label;
	gtk_label_set_xalign (_tmp16_, (gfloat) 0.0);
	_tmp17_ = label;
	gtk_label_set_yalign (_tmp17_, (gfloat) 0.5);
	_tmp18_ = label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp18_, TRUE);
	_tmp19_ = grid;
	_tmp20_ = label;
	gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 0, 0, 1, 1);
	_tmp21_ = (GtkComboBox*) gtk_combo_box_new ();
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->combobox);
	self->priv->combobox = _tmp21_;
	_tmp22_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp22_);
	_g_object_unref0 (renderer);
	renderer = _tmp22_;
	_tmp23_ = self->priv->combobox;
	_tmp24_ = renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp23_, (GtkCellRenderer*) _tmp24_, TRUE);
	_tmp25_ = self->priv->combobox;
	_tmp26_ = renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp25_, (GtkCellRenderer*) _tmp26_, "text", 0);
	_tmp27_ = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_INT, -1);
	_g_object_unref0 (model);
	model = _tmp27_;
	_tmp28_ = self->priv->combobox;
	_tmp29_ = model;
	gtk_combo_box_set_model (_tmp28_, (GtkTreeModel*) _tmp29_);
	_tmp30_ = model;
	gtk_list_store_append (_tmp30_, &_tmp31_);
	iter = _tmp31_;
	_tmp32_ = model;
	_tmp33_ = iter;
	gtk_list_store_set (_tmp32_, &_tmp33_, 0, _ ("Human"), 1, LEVEL_HUMAN, -1);
	_tmp34_ = prefs_get_instance ();
	_tmp35_ = _tmp34_;
	_tmp36_ = _tmp35_->level[PLAYER_ID_PLAYER2];
	if (_tmp36_ == LEVEL_HUMAN) {
		GtkComboBox* _tmp37_;
		GtkTreeIter _tmp38_;
		_tmp37_ = self->priv->combobox;
		_tmp38_ = iter;
		gtk_combo_box_set_active_iter (_tmp37_, &_tmp38_);
	}
	_tmp39_ = model;
	gtk_list_store_append (_tmp39_, &_tmp40_);
	iter = _tmp40_;
	_tmp41_ = model;
	_tmp42_ = iter;
	gtk_list_store_set (_tmp41_, &_tmp42_, 0, _ ("Level one"), 1, LEVEL_WEAK, -1);
	_tmp43_ = prefs_get_instance ();
	_tmp44_ = _tmp43_;
	_tmp45_ = _tmp44_->level[PLAYER_ID_PLAYER2];
	if (_tmp45_ == LEVEL_WEAK) {
		GtkComboBox* _tmp46_;
		GtkTreeIter _tmp47_;
		_tmp46_ = self->priv->combobox;
		_tmp47_ = iter;
		gtk_combo_box_set_active_iter (_tmp46_, &_tmp47_);
	}
	_tmp48_ = model;
	gtk_list_store_append (_tmp48_, &_tmp49_);
	iter = _tmp49_;
	_tmp50_ = model;
	_tmp51_ = iter;
	gtk_list_store_set (_tmp50_, &_tmp51_, 0, _ ("Level two"), 1, LEVEL_MEDIUM, -1);
	_tmp52_ = prefs_get_instance ();
	_tmp53_ = _tmp52_;
	_tmp54_ = _tmp53_->level[PLAYER_ID_PLAYER2];
	if (_tmp54_ == LEVEL_MEDIUM) {
		GtkComboBox* _tmp55_;
		GtkTreeIter _tmp56_;
		_tmp55_ = self->priv->combobox;
		_tmp56_ = iter;
		gtk_combo_box_set_active_iter (_tmp55_, &_tmp56_);
	}
	_tmp57_ = model;
	gtk_list_store_append (_tmp57_, &_tmp58_);
	iter = _tmp58_;
	_tmp59_ = model;
	_tmp60_ = iter;
	gtk_list_store_set (_tmp59_, &_tmp60_, 0, _ ("Level three"), 1, LEVEL_STRONG, -1);
	_tmp61_ = prefs_get_instance ();
	_tmp62_ = _tmp61_;
	_tmp63_ = _tmp62_->level[PLAYER_ID_PLAYER2];
	if (_tmp63_ == LEVEL_STRONG) {
		GtkComboBox* _tmp64_;
		GtkTreeIter _tmp65_;
		_tmp64_ = self->priv->combobox;
		_tmp65_ = iter;
		gtk_combo_box_set_active_iter (_tmp64_, &_tmp65_);
	}
	_tmp66_ = self->priv->combobox;
	g_signal_connect_object (_tmp66_, "changed", (GCallback) _prefs_box_on_select_opponent_gtk_combo_box_changed, self, 0);
	_tmp67_ = grid;
	_tmp68_ = self->priv->combobox;
	gtk_grid_attach (_tmp67_, (GtkWidget*) _tmp68_, 1, 0, 1, 1);
	_tmp69_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("_Theme:"));
	g_object_ref_sink (_tmp69_);
	_g_object_unref0 (label);
	label = _tmp69_;
	_tmp70_ = label;
	gtk_label_set_xalign (_tmp70_, (gfloat) 0.0);
	_tmp71_ = label;
	gtk_label_set_yalign (_tmp71_, (gfloat) 0.5);
	_tmp72_ = label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp72_, TRUE);
	_tmp73_ = grid;
	_tmp74_ = label;
	gtk_grid_attach (_tmp73_, (GtkWidget*) _tmp74_, 0, 1, 1, 1);
	_tmp75_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp75_);
	_g_object_unref0 (self->priv->combobox_theme);
	self->priv->combobox_theme = _tmp75_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp76_ = FALSE;
			_tmp76_ = TRUE;
			while (TRUE) {
				GtkComboBoxText* _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
				if (!_tmp76_) {
					gint _tmp77_;
					_tmp77_ = i;
					i = _tmp77_ + 1;
				}
				_tmp76_ = FALSE;
				if (!(i < G_N_ELEMENTS (theme))) {
					break;
				}
				_tmp78_ = self->priv->combobox_theme;
				_tmp79_ = theme_get_title (i);
				_tmp80_ = _tmp79_;
				gtk_combo_box_text_append_text (_tmp78_, _ (_tmp80_));
				_g_free0 (_tmp80_);
			}
		}
	}
	_tmp81_ = label;
	_tmp82_ = self->priv->combobox_theme;
	gtk_label_set_mnemonic_widget (_tmp81_, (GtkWidget*) _tmp82_);
	_tmp83_ = grid;
	_tmp84_ = self->priv->combobox_theme;
	gtk_grid_attach (_tmp83_, (GtkWidget*) _tmp84_, 1, 1, 1, 1);
	_tmp85_ = (GtkCheckButton*) gtk_check_button_new_with_mnemonic (_ ("E_nable sounds"));
	g_object_ref_sink (_tmp85_);
	_g_object_unref0 (self->priv->checkbutton_sound);
	self->priv->checkbutton_sound = (GtkToggleButton*) _tmp85_;
	_tmp86_ = grid;
	_tmp87_ = self->priv->checkbutton_sound;
	gtk_grid_attach (_tmp86_, (GtkWidget*) _tmp87_, 0, 2, 2, 1);
	_tmp88_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("Keyboard Controls"));
	g_object_ref_sink (_tmp88_);
	_g_object_unref0 (label);
	label = _tmp88_;
	_tmp89_ = prefs_get_instance ();
	_tmp90_ = _tmp89_;
	_tmp91_ = _tmp90_->settings;
	_tmp92_ = games_controls_list_new (_tmp91_);
	g_object_ref_sink (_tmp92_);
	_g_object_unref0 (controls_list);
	controls_list = _tmp92_;
	games_controls_list_add_controls (controls_list, "key-left", _ ("Move left"), DEFAULT_KEY_LEFT, "key-right", _ ("Move right"), DEFAULT_KEY_RIGHT, "key-drop", _ ("Drop marble"), DEFAULT_KEY_DROP, NULL);
	gtk_container_set_border_width ((GtkContainer*) controls_list, (guint) 12);
	_tmp93_ = self->priv->notebook;
	_tmp94_ = label;
	gtk_notebook_append_page (_tmp93_, (GtkWidget*) controls_list, (GtkWidget*) _tmp94_);
	_tmp95_ = self->priv->combobox_theme;
	_tmp96_ = prefs_get_instance ();
	_tmp97_ = _tmp96_;
	_tmp98_ = prefs_get_theme_id (_tmp97_);
	_tmp99_ = _tmp98_;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp95_, _tmp99_);
	_tmp100_ = self->priv->checkbutton_sound;
	_tmp101_ = prefs_get_instance ();
	_tmp102_ = _tmp101_;
	_tmp103_ = prefs_get_do_sound (_tmp102_);
	_tmp104_ = _tmp103_;
	gtk_toggle_button_set_active (_tmp100_, _tmp104_);
	_tmp105_ = self->priv->combobox_theme;
	g_signal_connect_object ((GtkComboBox*) _tmp105_, "changed", (GCallback) _prefs_box_on_select_theme_gtk_combo_box_changed, self, 0);
	_tmp106_ = self->priv->checkbutton_sound;
	_tmp107_ = prefs_get_instance ();
	_tmp108_ = _tmp107_;
	g_signal_connect_object (_tmp106_, "toggled", (GCallback) _prefs_on_toggle_sound_gtk_toggle_button_toggled, _tmp108_, 0);
	_tmp109_ = prefs_get_instance ();
	_tmp110_ = _tmp109_;
	g_signal_connect_object (_tmp110_, "theme-changed", (GCallback) ___lambda6__prefs_theme_changed, self, 0);
	_tmp111_ = prefs_get_instance ();
	_tmp112_ = _tmp111_;
	g_signal_connect_object ((GObject*) _tmp112_, "notify::do_sound", (GCallback) ___lambda7__g_object_notify, self, 0);
	_g_object_unref0 (model);
	_g_object_unref0 (renderer);
	_g_object_unref0 (label);
	_g_object_unref0 (controls_list);
	_g_object_unref0 (grid);
	return self;
}

PrefsBox*
prefs_box_new (GtkWindow* parent)
{
	return prefs_box_construct (TYPE_PREFS_BOX, parent);
}

static gboolean
prefs_box_real_delete_event (GtkWidget* base,
                             GdkEventAny* event)
{
	PrefsBox * self;
	gboolean result = FALSE;
	self = (PrefsBox*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	gtk_widget_hide ((GtkWidget*) self);
	result = TRUE;
	return result;
}

static void
prefs_box_on_select_theme (PrefsBox* self,
                           GtkComboBox* combo)
{
	gint id = 0;
	Prefs* _tmp0_;
	Prefs* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (combo != NULL);
	id = gtk_combo_box_get_active (combo);
	_tmp0_ = prefs_get_instance ();
	_tmp1_ = _tmp0_;
	prefs_set_theme_id (_tmp1_, id);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
prefs_box_on_select_opponent (PrefsBox* self,
                              GtkComboBox* w)
{
	FourInARow* app = NULL;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	FourInARow* _tmp2_;
	GtkTreeIter iter = {0};
	gint value = 0;
	GtkTreeIter _tmp3_ = {0};
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	gint _tmp6_ = 0;
	Prefs* _tmp7_;
	Prefs* _tmp8_;
	Prefs* _tmp9_;
	Prefs* _tmp10_;
	GSettings* _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (w != NULL);
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_FOUR_IN_AROW, FourInARow));
	app = _tmp2_;
	gtk_combo_box_get_active_iter (w, &_tmp3_);
	iter = _tmp3_;
	_tmp4_ = gtk_combo_box_get_model (w);
	_tmp5_ = iter;
	gtk_tree_model_get (_tmp4_, &_tmp5_, 1, &_tmp6_, -1);
	value = _tmp6_;
	_tmp7_ = prefs_get_instance ();
	_tmp8_ = _tmp7_;
	_tmp8_->level[PLAYER_ID_PLAYER2] = (Level) value;
	_tmp9_ = prefs_get_instance ();
	_tmp10_ = _tmp9_;
	_tmp11_ = _tmp10_->settings;
	g_settings_set_int (_tmp11_, "opponent", value);
	app->who_starts = PLAYER_ID_PLAYER2;
	four_in_arow_game_reset (app);
	_g_object_unref0 (app);
}

static void
prefs_box_class_init (PrefsBoxClass * klass,
                      gpointer klass_data)
{
	prefs_box_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PrefsBox_private_offset);
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) prefs_box_real_delete_event;
	G_OBJECT_CLASS (klass)->finalize = prefs_box_finalize;
}

static void
prefs_box_instance_init (PrefsBox * self,
                         gpointer klass)
{
	self->priv = prefs_box_get_instance_private (self);
}

static void
prefs_box_finalize (GObject * obj)
{
	PrefsBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFS_BOX, PrefsBox);
	_g_object_unref0 (self->priv->notebook);
	_g_object_unref0 (self->priv->combobox);
	_g_object_unref0 (self->priv->combobox_theme);
	_g_object_unref0 (self->priv->checkbutton_sound);
	G_OBJECT_CLASS (prefs_box_parent_class)->finalize (obj);
}

GType
prefs_box_get_type (void)
{
	static volatile gsize prefs_box_type_id__volatile = 0;
	if (g_once_init_enter (&prefs_box_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrefsBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prefs_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrefsBox), 0, (GInstanceInitFunc) prefs_box_instance_init, NULL };
		GType prefs_box_type_id;
		prefs_box_type_id = g_type_register_static (gtk_dialog_get_type (), "PrefsBox", &g_define_type_info, 0);
		PrefsBox_private_offset = g_type_add_instance_private (prefs_box_type_id, sizeof (PrefsBoxPrivate));
		g_once_init_leave (&prefs_box_type_id__volatile, prefs_box_type_id);
	}
	return prefs_box_type_id__volatile;
}

