/* prefs.c generated by valac 0.46.2, the Vala compiler
 * generated from prefs.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* prefs.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

#define TYPE_PREFS (prefs_get_type ())
#define PREFS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS, Prefs))
#define PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS, PrefsClass))
#define IS_PREFS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS))
#define IS_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS))
#define PREFS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS, PrefsClass))

typedef struct _Prefs Prefs;
typedef struct _PrefsClass PrefsClass;
typedef struct _PrefsPrivate PrefsPrivate;
typedef enum  {
	LEVEL_HUMAN,
	LEVEL_WEAK,
	LEVEL_MEDIUM,
	LEVEL_STRONG
} Level;

#define TYPE_LEVEL (level_get_type ())
enum  {
	PREFS_0_PROPERTY,
	PREFS_DO_SOUND_PROPERTY,
	PREFS_THEME_ID_PROPERTY,
	PREFS_KEYPRESS_DROP_PROPERTY,
	PREFS_KEYPRESS_RIGHT_PROPERTY,
	PREFS_KEYPRESS_LEFT_PROPERTY,
	PREFS_NUM_PROPERTIES
};
static GParamSpec* prefs_properties[PREFS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	PLAYER_ID_PLAYER1 = 0,
	PLAYER_ID_PLAYER2,
	PLAYER_ID_NOBODY
} PlayerID;

#define TYPE_PLAYER_ID (player_id_get_type ())

#define TYPE_THEME (theme_get_type ())
typedef struct _Theme Theme;
enum  {
	PREFS_THEME_CHANGED_SIGNAL,
	PREFS_NUM_SIGNALS
};
static guint prefs_signals[PREFS_NUM_SIGNALS] = {0};

struct _Prefs {
	GObject parent_instance;
	PrefsPrivate * priv;
	Level level[2];
	GSettings* settings;
};

struct _PrefsClass {
	GObjectClass parent_class;
};

struct _PrefsPrivate {
	gboolean _do_sound;
	gint _theme_id;
	gint _keypress_drop;
	gint _keypress_right;
	gint _keypress_left;
};

struct _Theme {
	gchar* title;
	gchar* fname_tileset;
	gchar* fname_bground;
	gchar* grid_color;
	gchar* player1;
	gchar* player2;
	gchar* player1_win;
	gchar* player2_win;
	gchar* player1_turn;
	gchar* player2_turn;
};

static gint Prefs_private_offset;
static gpointer prefs_parent_class = NULL;
static GOnce prefs__instance;
static GOnce prefs__instance = G_ONCE_INIT;

GType prefs_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Prefs, g_object_unref)
GType level_get_type (void) G_GNUC_CONST;
Prefs* prefs_new (void);
Prefs* prefs_construct (GType object_type);
GType player_id_get_type (void) G_GNUC_CONST;
void prefs_set_theme_id (Prefs* self,
                         gint value);
static void prefs_theme_id_changed_cb (Prefs* self,
                                const gchar* key);
static void _prefs_theme_id_changed_cb_g_settings_changed (GSettings* _sender,
                                                    const gchar* key,
                                                    gpointer self);
Level sane_player_level (Level val);
static gint prefs_sane_theme_id (gint val);
gint prefs_get_theme_id (Prefs* self);
GType theme_get_type (void) G_GNUC_CONST;
Theme* theme_dup (const Theme* self);
void theme_free (Theme* self);
void theme_copy (const Theme* self,
                 Theme* dest);
void theme_destroy (Theme* self);
#define DEFAULT_THEME_ID 0
gint prefs_get_n_human_players (Prefs* self);
void prefs_on_toggle_sound (Prefs* self,
                            GtkToggleButton* t);
void prefs_set_do_sound (Prefs* self,
                         gboolean value);
gboolean prefs_get_do_sound (Prefs* self);
gint prefs_get_keypress_drop (Prefs* self);
void prefs_set_keypress_drop (Prefs* self,
                              gint value);
gint prefs_get_keypress_right (Prefs* self);
void prefs_set_keypress_right (Prefs* self,
                               gint value);
gint prefs_get_keypress_left (Prefs* self);
void prefs_set_keypress_left (Prefs* self,
                              gint value);
Prefs* prefs_get_instance (void);
static Prefs* _prefs_instance___lambda4_ (void);
static gpointer __prefs_instance___lambda4__gthread_func (gpointer self);
static void prefs_finalize (GObject * obj);
static void _vala_prefs_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_prefs_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
#define DEFAULT_KEY_LEFT GDK_KEY_Left
#define DEFAULT_KEY_RIGHT GDK_KEY_Right
#define DEFAULT_KEY_DROP GDK_KEY_Down

extern const Theme theme[5];

static inline gpointer
prefs_get_instance_private (Prefs* self)
{
	return G_STRUCT_MEMBER_P (self, Prefs_private_offset);
}

static void
_prefs_theme_id_changed_cb_g_settings_changed (GSettings* _sender,
                                               const gchar* key,
                                               gpointer self)
{
	prefs_theme_id_changed_cb ((Prefs*) self, key);
}

Prefs*
prefs_construct (GType object_type)
{
	Prefs * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	Level _tmp9_;
	Level _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	self = (Prefs*) g_object_new (object_type, NULL);
	_tmp0_ = g_settings_new ("org.gnome.Four-in-a-row");
	_g_object_unref0 (self->settings);
	self->settings = _tmp0_;
	self->level[PLAYER_ID_PLAYER1] = LEVEL_HUMAN;
	_tmp1_ = self->settings;
	self->level[PLAYER_ID_PLAYER2] = (Level) g_settings_get_int (_tmp1_, "opponent");
	_tmp2_ = self->settings;
	prefs_set_theme_id (self, g_settings_get_int (_tmp2_, "theme-id"));
	_tmp3_ = self->settings;
	g_signal_connect_object (_tmp3_, "changed::theme-id", (GCallback) _prefs_theme_id_changed_cb_g_settings_changed, self, 0);
	_tmp4_ = self->settings;
	g_settings_bind (_tmp4_, "sound", (GObject*) self, "do_sound", G_SETTINGS_BIND_DEFAULT);
	_tmp5_ = self->settings;
	g_settings_bind (_tmp5_, "theme-id", (GObject*) self, "theme-id", G_SETTINGS_BIND_DEFAULT);
	_tmp6_ = self->settings;
	g_settings_bind (_tmp6_, "key-drop", (GObject*) self, "keypress_drop", G_SETTINGS_BIND_DEFAULT);
	_tmp7_ = self->settings;
	g_settings_bind (_tmp7_, "key-right", (GObject*) self, "keypress_right", G_SETTINGS_BIND_DEFAULT);
	_tmp8_ = self->settings;
	g_settings_bind (_tmp8_, "key-left", (GObject*) self, "keypress_left", G_SETTINGS_BIND_DEFAULT);
	_tmp9_ = self->level[PLAYER_ID_PLAYER1];
	self->level[PLAYER_ID_PLAYER1] = sane_player_level (_tmp9_);
	_tmp10_ = self->level[PLAYER_ID_PLAYER2];
	self->level[PLAYER_ID_PLAYER2] = sane_player_level (_tmp10_);
	_tmp11_ = prefs_get_theme_id (self);
	_tmp12_ = _tmp11_;
	prefs_set_theme_id (self, prefs_sane_theme_id (_tmp12_));
	return self;
}

Prefs*
prefs_new (void)
{
	return prefs_construct (TYPE_PREFS);
}

static gint
prefs_sane_theme_id (gint val)
{
	gboolean _tmp0_ = FALSE;
	gint result = 0;
	if (val < 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = val >= G_N_ELEMENTS (theme);
	}
	if (_tmp0_) {
		result = DEFAULT_THEME_ID;
		return result;
	}
	result = val;
	return result;
}

static void
prefs_theme_id_changed_cb (Prefs* self,
                           const gchar* key)
{
	gint val = 0;
	GSettings* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = self->settings;
	val = prefs_sane_theme_id (g_settings_get_int (_tmp0_, "theme-id"));
	_tmp1_ = prefs_get_theme_id (self);
	_tmp2_ = _tmp1_;
	if (val != _tmp2_) {
		prefs_set_theme_id (self, val);
	}
	_tmp3_ = prefs_get_theme_id (self);
	_tmp4_ = _tmp3_;
	g_signal_emit (self, prefs_signals[PREFS_THEME_CHANGED_SIGNAL], 0, _tmp4_);
}

gint
prefs_get_n_human_players (Prefs* self)
{
	gboolean _tmp0_ = FALSE;
	Level _tmp1_;
	gboolean _tmp3_ = FALSE;
	Level _tmp4_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp1_ = self->level[PLAYER_ID_PLAYER1];
	if (_tmp1_ != LEVEL_HUMAN) {
		Level _tmp2_;
		_tmp2_ = self->level[PLAYER_ID_PLAYER2];
		_tmp0_ = _tmp2_ != LEVEL_HUMAN;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = 0;
		return result;
	}
	_tmp4_ = self->level[PLAYER_ID_PLAYER1];
	if (_tmp4_ != LEVEL_HUMAN) {
		_tmp3_ = TRUE;
	} else {
		Level _tmp5_;
		_tmp5_ = self->level[PLAYER_ID_PLAYER2];
		_tmp3_ = _tmp5_ != LEVEL_HUMAN;
	}
	if (_tmp3_) {
		result = 1;
		return result;
	}
	result = 2;
	return result;
}

void
prefs_on_toggle_sound (Prefs* self,
                       GtkToggleButton* t)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (t != NULL);
	prefs_set_do_sound (self, gtk_toggle_button_get_active (t));
}

gboolean
prefs_get_do_sound (Prefs* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_do_sound;
	return result;
}

void
prefs_set_do_sound (Prefs* self,
                    gboolean value)
{
	g_return_if_fail (self != NULL);
	if (prefs_get_do_sound (self) != value) {
		self->priv->_do_sound = value;
		g_object_notify_by_pspec ((GObject *) self, prefs_properties[PREFS_DO_SOUND_PROPERTY]);
	}
}

gint
prefs_get_theme_id (Prefs* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = prefs_sane_theme_id (self->priv->_theme_id);
	return result;
}

void
prefs_set_theme_id (Prefs* self,
                    gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_theme_id = prefs_sane_theme_id (value);
	g_object_notify_by_pspec ((GObject *) self, prefs_properties[PREFS_THEME_ID_PROPERTY]);
}

gint
prefs_get_keypress_drop (Prefs* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_keypress_drop;
	return result;
}

void
prefs_set_keypress_drop (Prefs* self,
                         gint value)
{
	g_return_if_fail (self != NULL);
	if (prefs_get_keypress_drop (self) != value) {
		self->priv->_keypress_drop = value;
		g_object_notify_by_pspec ((GObject *) self, prefs_properties[PREFS_KEYPRESS_DROP_PROPERTY]);
	}
}

gint
prefs_get_keypress_right (Prefs* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_keypress_right;
	return result;
}

void
prefs_set_keypress_right (Prefs* self,
                          gint value)
{
	g_return_if_fail (self != NULL);
	if (prefs_get_keypress_right (self) != value) {
		self->priv->_keypress_right = value;
		g_object_notify_by_pspec ((GObject *) self, prefs_properties[PREFS_KEYPRESS_RIGHT_PROPERTY]);
	}
}

gint
prefs_get_keypress_left (Prefs* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_keypress_left;
	return result;
}

void
prefs_set_keypress_left (Prefs* self,
                         gint value)
{
	g_return_if_fail (self != NULL);
	if (prefs_get_keypress_left (self) != value) {
		self->priv->_keypress_left = value;
		g_object_notify_by_pspec ((GObject *) self, prefs_properties[PREFS_KEYPRESS_LEFT_PROPERTY]);
	}
}

static Prefs*
_prefs_instance___lambda4_ (void)
{
	Prefs* _tmp0_;
	Prefs* result = NULL;
	_tmp0_ = prefs_new ();
	result = _tmp0_;
	return result;
}

static gpointer
__prefs_instance___lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = _prefs_instance___lambda4_ ();
	return result;
}

Prefs*
prefs_get_instance (void)
{
	Prefs* result;
	gconstpointer _tmp0_;
	_tmp0_ = g_once (&prefs__instance, __prefs_instance___lambda4__gthread_func, NULL);
	result = (Prefs*) _tmp0_;
	return result;
}

static void
prefs_class_init (PrefsClass * klass,
                  gpointer klass_data)
{
	prefs_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Prefs_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_prefs_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_prefs_set_property;
	G_OBJECT_CLASS (klass)->finalize = prefs_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_DO_SOUND_PROPERTY, prefs_properties[PREFS_DO_SOUND_PROPERTY] = g_param_spec_boolean ("do-sound", "do-sound", "do-sound", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_THEME_ID_PROPERTY, prefs_properties[PREFS_THEME_ID_PROPERTY] = g_param_spec_int ("theme-id", "theme-id", "theme-id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_KEYPRESS_DROP_PROPERTY, prefs_properties[PREFS_KEYPRESS_DROP_PROPERTY] = g_param_spec_int ("keypress-drop", "keypress-drop", "keypress-drop", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_KEYPRESS_RIGHT_PROPERTY, prefs_properties[PREFS_KEYPRESS_RIGHT_PROPERTY] = g_param_spec_int ("keypress-right", "keypress-right", "keypress-right", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFS_KEYPRESS_LEFT_PROPERTY, prefs_properties[PREFS_KEYPRESS_LEFT_PROPERTY] = g_param_spec_int ("keypress-left", "keypress-left", "keypress-left", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	     * theme_changed:
	     *
	     * emmited when the theme is changed
	     *
	     * @theme_id: The new theme_id
	     */
	prefs_signals[PREFS_THEME_CHANGED_SIGNAL] = g_signal_new ("theme-changed", TYPE_PREFS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
}

static void
prefs_instance_init (Prefs * self,
                     gpointer klass)
{
	self->priv = prefs_get_instance_private (self);
}

static void
prefs_finalize (GObject * obj)
{
	Prefs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFS, Prefs);
	_g_object_unref0 (self->settings);
	G_OBJECT_CLASS (prefs_parent_class)->finalize (obj);
}

GType
prefs_get_type (void)
{
	static volatile gsize prefs_type_id__volatile = 0;
	if (g_once_init_enter (&prefs_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrefsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prefs_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Prefs), 0, (GInstanceInitFunc) prefs_instance_init, NULL };
		GType prefs_type_id;
		prefs_type_id = g_type_register_static (G_TYPE_OBJECT, "Prefs", &g_define_type_info, 0);
		Prefs_private_offset = g_type_add_instance_private (prefs_type_id, sizeof (PrefsPrivate));
		g_once_init_leave (&prefs_type_id__volatile, prefs_type_id);
	}
	return prefs_type_id__volatile;
}

static void
_vala_prefs_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Prefs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PREFS, Prefs);
	switch (property_id) {
		case PREFS_DO_SOUND_PROPERTY:
		g_value_set_boolean (value, prefs_get_do_sound (self));
		break;
		case PREFS_THEME_ID_PROPERTY:
		g_value_set_int (value, prefs_get_theme_id (self));
		break;
		case PREFS_KEYPRESS_DROP_PROPERTY:
		g_value_set_int (value, prefs_get_keypress_drop (self));
		break;
		case PREFS_KEYPRESS_RIGHT_PROPERTY:
		g_value_set_int (value, prefs_get_keypress_right (self));
		break;
		case PREFS_KEYPRESS_LEFT_PROPERTY:
		g_value_set_int (value, prefs_get_keypress_left (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_prefs_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Prefs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PREFS, Prefs);
	switch (property_id) {
		case PREFS_DO_SOUND_PROPERTY:
		prefs_set_do_sound (self, g_value_get_boolean (value));
		break;
		case PREFS_THEME_ID_PROPERTY:
		prefs_set_theme_id (self, g_value_get_int (value));
		break;
		case PREFS_KEYPRESS_DROP_PROPERTY:
		prefs_set_keypress_drop (self, g_value_get_int (value));
		break;
		case PREFS_KEYPRESS_RIGHT_PROPERTY:
		prefs_set_keypress_right (self, g_value_get_int (value));
		break;
		case PREFS_KEYPRESS_LEFT_PROPERTY:
		prefs_set_keypress_left (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

Level
sane_player_level (Level val)
{
	Level result = 0;
	if (val < LEVEL_HUMAN) {
		result = LEVEL_HUMAN;
		return result;
	}
	if (val > LEVEL_STRONG) {
		result = LEVEL_STRONG;
		return result;
	}
	result = val;
	return result;
}

