/* scorebox.c generated by valac 0.46.2, the Vala compiler
 * generated from scorebox.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * scorebox.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>

#define TYPE_SCOREBOX (scorebox_get_type ())
#define SCOREBOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCOREBOX, Scorebox))
#define SCOREBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCOREBOX, ScoreboxClass))
#define IS_SCOREBOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCOREBOX))
#define IS_SCOREBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCOREBOX))
#define SCOREBOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCOREBOX, ScoreboxClass))

typedef struct _Scorebox Scorebox;
typedef struct _ScoreboxClass ScoreboxClass;
typedef struct _ScoreboxPrivate ScoreboxPrivate;

#define TYPE_FOUR_IN_AROW (four_in_arow_get_type ())
#define FOUR_IN_AROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FOUR_IN_AROW, FourInARow))
#define FOUR_IN_AROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FOUR_IN_AROW, FourInARowClass))
#define IS_FOUR_IN_AROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FOUR_IN_AROW))
#define IS_FOUR_IN_AROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FOUR_IN_AROW))
#define FOUR_IN_AROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FOUR_IN_AROW, FourInARowClass))

typedef struct _FourInARow FourInARow;
typedef struct _FourInARowClass FourInARowClass;
enum  {
	SCOREBOX_0_PROPERTY,
	SCOREBOX_NUM_PROPERTIES
};
static GParamSpec* scorebox_properties[SCOREBOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	PLAYER_ID_PLAYER1 = 0,
	PLAYER_ID_PLAYER2,
	PLAYER_ID_NOBODY
} PlayerID;

#define TYPE_PLAYER_ID (player_id_get_type ())

#define TYPE_PREFS (prefs_get_type ())
#define PREFS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS, Prefs))
#define PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS, PrefsClass))
#define IS_PREFS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS))
#define IS_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS))
#define PREFS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS, PrefsClass))

typedef struct _Prefs Prefs;
typedef struct _PrefsClass PrefsClass;
typedef struct _PrefsPrivate PrefsPrivate;
typedef enum  {
	LEVEL_HUMAN,
	LEVEL_WEAK,
	LEVEL_MEDIUM,
	LEVEL_STRONG
} Level;

#define TYPE_LEVEL (level_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Scorebox {
	GtkDialog parent_instance;
	ScoreboxPrivate * priv;
	FourInARow* application;
};

struct _ScoreboxClass {
	GtkDialogClass parent_class;
};

struct _ScoreboxPrivate {
	GtkLabel** label_name;
	gint label_name_length1;
	gint _label_name_size_;
	GtkLabel* label_score[3];
};

struct _Prefs {
	GObject parent_instance;
	PrefsPrivate * priv;
	Level level[2];
	GSettings* settings;
};

struct _PrefsClass {
	GObjectClass parent_class;
};

static gint Scorebox_private_offset;
static gpointer scorebox_parent_class = NULL;

GType scorebox_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Scorebox, g_object_unref)
GType four_in_arow_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FourInARow, g_object_unref)
Scorebox* scorebox_new (GtkWindow* parent,
                        FourInARow* application);
Scorebox* scorebox_construct (GType object_type,
                              GtkWindow* parent,
                              FourInARow* application);
GType player_id_get_type (void) G_GNUC_CONST;
void scorebox_update (Scorebox* self,
                      gint* scores,
                      gint scores_length1);
GType prefs_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Prefs, g_object_unref)
Prefs* prefs_get_instance (void);
gint prefs_get_n_human_players (Prefs* self);
GType level_get_type (void) G_GNUC_CONST;
gchar* theme_get_player (PlayerID who);
static gboolean scorebox_real_delete_event (GtkWidget* base,
                                     GdkEventAny* event);
static void scorebox_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
scorebox_get_instance_private (Scorebox* self)
{
	return G_STRUCT_MEMBER_P (self, Scorebox_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

Scorebox*
scorebox_construct (GType object_type,
                    GtkWindow* parent,
                    FourInARow* application)
{
	Scorebox * self = NULL;
	GtkBox* _tmp0_;
	GtkGrid* grid = NULL;
	GtkGrid* grid2 = NULL;
	GtkLabel** _tmp1_;
	GtkGrid* _tmp2_;
	GtkBox* _tmp3_;
	GtkGrid* _tmp4_;
	GtkLabel** _tmp5_;
	gint _tmp5__length1;
	GtkLabel* _tmp6_;
	GtkLabel** _tmp7_;
	gint _tmp7__length1;
	GtkLabel* _tmp8_;
	GtkLabel** _tmp9_;
	gint _tmp9__length1;
	GtkLabel* _tmp10_;
	GtkLabel** _tmp11_;
	gint _tmp11__length1;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel** _tmp17_;
	gint _tmp17__length1;
	GtkLabel* _tmp18_;
	GtkLabel** _tmp19_;
	gint _tmp19__length1;
	GtkLabel* _tmp20_;
	GtkLabel** _tmp21_;
	gint _tmp21__length1;
	GtkLabel* _tmp22_;
	GtkLabel** _tmp23_;
	gint _tmp23__length1;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel** _tmp29_;
	gint _tmp29__length1;
	GtkLabel* _tmp30_;
	GtkLabel** _tmp31_;
	gint _tmp31__length1;
	GtkLabel* _tmp32_;
	GtkLabel** _tmp33_;
	gint _tmp33__length1;
	GtkLabel* _tmp34_;
	GtkLabel** _tmp35_;
	gint _tmp35__length1;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	FourInARow* _tmp41_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (application != NULL, NULL);
	self = (Scorebox*) g_object_new (object_type, "title", _ ("Scores"), "use-header-bar", 1, "destroy-with-parent", TRUE, "resizable", FALSE, "border-width", 5, NULL);
	_tmp0_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	gtk_box_set_spacing (_tmp0_, 2);
	gtk_window_set_transient_for ((GtkWindow*) self, parent);
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	_tmp1_ = g_new0 (GtkLabel*, 3 + 1);
	self->priv->label_name = (_vala_array_free (self->priv->label_name, self->priv->label_name_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->label_name = _tmp1_;
	self->priv->label_name_length1 = 3;
	self->priv->_label_name_size_ = self->priv->label_name_length1;
	_tmp2_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (grid);
	grid = _tmp2_;
	gtk_widget_set_halign ((GtkWidget*) grid, GTK_ALIGN_CENTER);
	gtk_grid_set_row_spacing (grid, 6);
	gtk_orientable_set_orientation ((GtkOrientable*) grid, GTK_ORIENTATION_VERTICAL);
	gtk_container_set_border_width ((GtkContainer*) grid, (guint) 5);
	_tmp3_ = gtk_dialog_get_content_area ((GtkDialog*) self);
	gtk_box_pack_start (_tmp3_, (GtkWidget*) grid, TRUE, TRUE, (guint) 0);
	_tmp4_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (grid2);
	grid2 = _tmp4_;
	gtk_container_add ((GtkContainer*) grid, (GtkWidget*) grid2);
	gtk_grid_set_column_spacing (grid2, 6);
	_tmp5_ = self->priv->label_name;
	_tmp5__length1 = self->priv->label_name_length1;
	_tmp6_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (_tmp5_[PLAYER_ID_PLAYER1]);
	_tmp5_[PLAYER_ID_PLAYER1] = _tmp6_;
	_tmp7_ = self->priv->label_name;
	_tmp7__length1 = self->priv->label_name_length1;
	_tmp8_ = _tmp7_[PLAYER_ID_PLAYER1];
	gtk_grid_attach (grid2, (GtkWidget*) _tmp8_, 0, 0, 1, 1);
	_tmp9_ = self->priv->label_name;
	_tmp9__length1 = self->priv->label_name_length1;
	_tmp10_ = _tmp9_[PLAYER_ID_PLAYER1];
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
	_tmp11_ = self->priv->label_name;
	_tmp11__length1 = self->priv->label_name_length1;
	_tmp12_ = _tmp11_[PLAYER_ID_PLAYER1];
	gtk_label_set_yalign (_tmp12_, 0.5f);
	_tmp13_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->label_score[PLAYER_ID_PLAYER1]);
	self->priv->label_score[PLAYER_ID_PLAYER1] = _tmp13_;
	_tmp14_ = self->priv->label_score[PLAYER_ID_PLAYER1];
	gtk_grid_attach (grid2, (GtkWidget*) _tmp14_, 1, 0, 1, 1);
	_tmp15_ = self->priv->label_score[PLAYER_ID_PLAYER1];
	gtk_label_set_xalign (_tmp15_, (gfloat) 0);
	_tmp16_ = self->priv->label_score[PLAYER_ID_PLAYER1];
	gtk_label_set_yalign (_tmp16_, 0.5f);
	_tmp17_ = self->priv->label_name;
	_tmp17__length1 = self->priv->label_name_length1;
	_tmp18_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp18_);
	_g_object_unref0 (_tmp17_[PLAYER_ID_PLAYER2]);
	_tmp17_[PLAYER_ID_PLAYER2] = _tmp18_;
	_tmp19_ = self->priv->label_name;
	_tmp19__length1 = self->priv->label_name_length1;
	_tmp20_ = _tmp19_[PLAYER_ID_PLAYER2];
	gtk_grid_attach (grid2, (GtkWidget*) _tmp20_, 0, 1, 1, 1);
	_tmp21_ = self->priv->label_name;
	_tmp21__length1 = self->priv->label_name_length1;
	_tmp22_ = _tmp21_[PLAYER_ID_PLAYER2];
	gtk_label_set_xalign (_tmp22_, (gfloat) 0);
	_tmp23_ = self->priv->label_name;
	_tmp23__length1 = self->priv->label_name_length1;
	_tmp24_ = _tmp23_[PLAYER_ID_PLAYER2];
	gtk_label_set_yalign (_tmp24_, 0.5f);
	_tmp25_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp25_);
	_g_object_unref0 (self->priv->label_score[PLAYER_ID_PLAYER2]);
	self->priv->label_score[PLAYER_ID_PLAYER2] = _tmp25_;
	_tmp26_ = self->priv->label_score[PLAYER_ID_PLAYER2];
	gtk_grid_attach (grid2, (GtkWidget*) _tmp26_, 1, 1, 1, 1);
	_tmp27_ = self->priv->label_score[PLAYER_ID_PLAYER2];
	gtk_label_set_xalign (_tmp27_, (gfloat) 0);
	_tmp28_ = self->priv->label_score[PLAYER_ID_PLAYER2];
	gtk_label_set_yalign (_tmp28_, 0.5f);
	_tmp29_ = self->priv->label_name;
	_tmp29__length1 = self->priv->label_name_length1;
	_tmp30_ = (GtkLabel*) gtk_label_new (_ ("Drawn:"));
	g_object_ref_sink (_tmp30_);
	_g_object_unref0 (_tmp29_[PLAYER_ID_NOBODY]);
	_tmp29_[PLAYER_ID_NOBODY] = _tmp30_;
	_tmp31_ = self->priv->label_name;
	_tmp31__length1 = self->priv->label_name_length1;
	_tmp32_ = _tmp31_[PLAYER_ID_NOBODY];
	gtk_grid_attach (grid2, (GtkWidget*) _tmp32_, 0, 2, 1, 1);
	_tmp33_ = self->priv->label_name;
	_tmp33__length1 = self->priv->label_name_length1;
	_tmp34_ = _tmp33_[PLAYER_ID_NOBODY];
	gtk_label_set_xalign (_tmp34_, (gfloat) 0);
	_tmp35_ = self->priv->label_name;
	_tmp35__length1 = self->priv->label_name_length1;
	_tmp36_ = _tmp35_[PLAYER_ID_NOBODY];
	gtk_label_set_yalign (_tmp36_, 0.5f);
	_tmp37_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp37_);
	_g_object_unref0 (self->priv->label_score[PLAYER_ID_NOBODY]);
	self->priv->label_score[PLAYER_ID_NOBODY] = _tmp37_;
	_tmp38_ = self->priv->label_score[PLAYER_ID_NOBODY];
	gtk_grid_attach (grid2, (GtkWidget*) _tmp38_, 1, 2, 1, 1);
	_tmp39_ = self->priv->label_score[PLAYER_ID_NOBODY];
	gtk_label_set_xalign (_tmp39_, (gfloat) 0);
	_tmp40_ = self->priv->label_score[PLAYER_ID_NOBODY];
	gtk_label_set_yalign (_tmp40_, 0.5f);
	gtk_widget_show_all ((GtkWidget*) grid);
	_tmp41_ = _g_object_ref0 (application);
	_g_object_unref0 (self->application);
	self->application = _tmp41_;
	_g_object_unref0 (grid2);
	_g_object_unref0 (grid);
	return self;
}

Scorebox*
scorebox_new (GtkWindow* parent,
              FourInARow* application)
{
	return scorebox_construct (TYPE_SCOREBOX, parent, application);
}

/**
     * update:
     *
     * updates the scorebox with the latest scores
     */
void
scorebox_update (Scorebox* self,
                 gint* scores,
                 gint scores_length1)
{
	Prefs* _tmp0_;
	Prefs* _tmp1_;
	GtkLabel* _tmp21_;
	gint _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GtkLabel* _tmp25_;
	gint _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	GtkLabel* _tmp29_;
	gint _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	g_return_if_fail (self != NULL);
	_tmp0_ = prefs_get_instance ();
	_tmp1_ = _tmp0_;
	if (prefs_get_n_human_players (_tmp1_) == 1) {
		Prefs* _tmp2_;
		Prefs* _tmp3_;
		Level _tmp4_;
		_tmp2_ = prefs_get_instance ();
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_->level[PLAYER_ID_PLAYER1];
		if (_tmp4_ == LEVEL_HUMAN) {
			GtkLabel** _tmp5_;
			gint _tmp5__length1;
			GtkLabel* _tmp6_;
			GtkLabel** _tmp7_;
			gint _tmp7__length1;
			GtkLabel* _tmp8_;
			_tmp5_ = self->priv->label_name;
			_tmp5__length1 = self->priv->label_name_length1;
			_tmp6_ = _tmp5_[PLAYER_ID_PLAYER1];
			gtk_label_set_text (_tmp6_, _ ("You:"));
			_tmp7_ = self->priv->label_name;
			_tmp7__length1 = self->priv->label_name_length1;
			_tmp8_ = _tmp7_[PLAYER_ID_PLAYER2];
			gtk_label_set_label (_tmp8_, _ ("Me:"));
		} else {
			GtkLabel** _tmp9_;
			gint _tmp9__length1;
			GtkLabel* _tmp10_;
			GtkLabel** _tmp11_;
			gint _tmp11__length1;
			GtkLabel* _tmp12_;
			_tmp9_ = self->priv->label_name;
			_tmp9__length1 = self->priv->label_name_length1;
			_tmp10_ = _tmp9_[PLAYER_ID_PLAYER2];
			gtk_label_set_text (_tmp10_, _ ("You:"));
			_tmp11_ = self->priv->label_name;
			_tmp11__length1 = self->priv->label_name_length1;
			_tmp12_ = _tmp11_[PLAYER_ID_PLAYER1];
			gtk_label_set_label (_tmp12_, _ ("Me:"));
		}
	} else {
		GtkLabel** _tmp13_;
		gint _tmp13__length1;
		GtkLabel* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		GtkLabel** _tmp17_;
		gint _tmp17__length1;
		GtkLabel* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp13_ = self->priv->label_name;
		_tmp13__length1 = self->priv->label_name_length1;
		_tmp14_ = _tmp13_[PLAYER_ID_PLAYER1];
		_tmp15_ = theme_get_player (PLAYER_ID_PLAYER1);
		_tmp16_ = _tmp15_;
		gtk_label_set_label (_tmp14_, _tmp16_);
		_g_free0 (_tmp16_);
		_tmp17_ = self->priv->label_name;
		_tmp17__length1 = self->priv->label_name_length1;
		_tmp18_ = _tmp17_[PLAYER_ID_PLAYER2];
		_tmp19_ = theme_get_player (PLAYER_ID_PLAYER2);
		_tmp20_ = _tmp19_;
		gtk_label_set_label (_tmp18_, _tmp20_);
		_g_free0 (_tmp20_);
	}
	_tmp21_ = self->priv->label_score[PLAYER_ID_PLAYER1];
	_tmp22_ = scores[PLAYER_ID_PLAYER1];
	_tmp23_ = g_strdup_printf ("%i", _tmp22_);
	_tmp24_ = _tmp23_;
	gtk_label_set_label (_tmp21_, _tmp24_);
	_g_free0 (_tmp24_);
	_tmp25_ = self->priv->label_score[PLAYER_ID_PLAYER2];
	_tmp26_ = scores[PLAYER_ID_PLAYER2];
	_tmp27_ = g_strdup_printf ("%i", _tmp26_);
	_tmp28_ = _tmp27_;
	gtk_label_set_label (_tmp25_, _tmp28_);
	_g_free0 (_tmp28_);
	_tmp29_ = self->priv->label_score[PLAYER_ID_NOBODY];
	_tmp30_ = scores[PLAYER_ID_NOBODY];
	_tmp31_ = g_strdup_printf ("%i", _tmp30_);
	_tmp32_ = _tmp31_;
	gtk_label_set_label (_tmp29_, _tmp32_);
	_g_free0 (_tmp32_);
}

static gboolean
scorebox_real_delete_event (GtkWidget* base,
                            GdkEventAny* event)
{
	Scorebox * self;
	gboolean result = FALSE;
	self = (Scorebox*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	gtk_widget_hide ((GtkWidget*) self);
	result = TRUE;
	return result;
}

static void
scorebox_class_init (ScoreboxClass * klass,
                     gpointer klass_data)
{
	scorebox_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Scorebox_private_offset);
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) scorebox_real_delete_event;
	G_OBJECT_CLASS (klass)->finalize = scorebox_finalize;
}

static void
scorebox_instance_init (Scorebox * self,
                        gpointer klass)
{
	self->priv = scorebox_get_instance_private (self);
}

static void
scorebox_finalize (GObject * obj)
{
	Scorebox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCOREBOX, Scorebox);
	self->priv->label_name = (_vala_array_free (self->priv->label_name, self->priv->label_name_length1, (GDestroyNotify) g_object_unref), NULL);
	_vala_array_destroy (self->priv->label_score, 3, (GDestroyNotify) g_object_unref);
	_g_object_unref0 (self->application);
	G_OBJECT_CLASS (scorebox_parent_class)->finalize (obj);
}

GType
scorebox_get_type (void)
{
	static volatile gsize scorebox_type_id__volatile = 0;
	if (g_once_init_enter (&scorebox_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ScoreboxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) scorebox_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Scorebox), 0, (GInstanceInitFunc) scorebox_instance_init, NULL };
		GType scorebox_type_id;
		scorebox_type_id = g_type_register_static (gtk_dialog_get_type (), "Scorebox", &g_define_type_info, 0);
		Scorebox_private_offset = g_type_add_instance_private (scorebox_type_id, sizeof (ScoreboxPrivate));
		g_once_init_leave (&scorebox_type_id__volatile, scorebox_type_id);
	}
	return scorebox_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

