/* theme.c generated by valac 0.46.2, the Vala compiler
 * generated from theme.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * theme.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#define TYPE_THEME (theme_get_type ())
typedef struct _Theme Theme;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	PLAYER_ID_PLAYER1 = 0,
	PLAYER_ID_PLAYER2,
	PLAYER_ID_NOBODY
} PlayerID;

#define TYPE_PLAYER_ID (player_id_get_type ())

#define TYPE_PREFS (prefs_get_type ())
#define PREFS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS, Prefs))
#define PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS, PrefsClass))
#define IS_PREFS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS))
#define IS_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS))
#define PREFS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS, PrefsClass))

typedef struct _Prefs Prefs;
typedef struct _PrefsClass PrefsClass;

struct _Theme {
	gchar* title;
	gchar* fname_tileset;
	gchar* fname_bground;
	gchar* grid_color;
	gchar* player1;
	gchar* player2;
	gchar* player1_win;
	gchar* player2_win;
	gchar* player1_turn;
	gchar* player2_turn;
};

GType theme_get_type (void) G_GNUC_CONST;
Theme* theme_dup (const Theme* self);
void theme_free (Theme* self);
void theme_copy (const Theme* self,
                 Theme* dest);
void theme_destroy (Theme* self);
#define theme_gettext_package GETTEXT_PACKAGE
gchar* theme_get_title (gint id);
GType player_id_get_type (void) G_GNUC_CONST;
gchar* theme_get_player_turn (PlayerID who);
GType prefs_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Prefs, g_object_unref)
Prefs* prefs_get_instance (void);
gint prefs_get_theme_id (Prefs* self);
gchar* theme_get_player_win (PlayerID who);
gchar* theme_get_player (PlayerID who);

const Theme theme[5] = {{N_ ("High Contrast"), "tileset_50x50_hcontrast.svg", NULL, "#000000", N_ ("Circle"), N_ ("Cross"), N_ ("Circle wins!"), N_ ("Cross wins!"), N_ ("Circle’s turn"), N_ ("Cross’s turn")}, {N_ ("High Contrast Inverse"), "tileset_50x50_hcinverse.svg", NULL, "#FFFFFF", N_ ("Circle"), N_ ("Cross"), N_ ("Circle wins!"), N_ ("Cross wins!"), N_ ("Circle’s turn"), N_ ("Cross’s turn")}, {N_ ("Red and Green Marbles"), "tileset_50x50_faenza-glines-icon1.svg", "bg_toplight.png", "#727F8C", N_ ("Red"), N_ ("Green"), N_ ("Red wins!"), N_ ("Green wins!"), N_ ("Red’s turn"), N_ ("Green’s turn")}, {N_ ("Blue and Red Marbles"), "tileset_50x50_faenza-glines-icon2.svg", "bg_toplight.png", "#727F8C", N_ ("Blue"), N_ ("Red"), N_ ("Blue wins!"), N_ ("Red wins!"), N_ ("Blue’s turn"), N_ ("Red’s turn")}, {N_ ("Stars and Rings"), "tileset_50x50_faenza-gnect-icon.svg", "bg_toplight.png", "#727F8C", N_ ("Red"), N_ ("Green"), N_ ("Red wins!"), N_ ("Green wins!"), N_ ("Red’s turn"), N_ ("Green’s turn")}};

void
theme_copy (const Theme* self,
            Theme* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	_tmp0_ = (*self).title;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).title);
	(*dest).title = _tmp1_;
	_tmp2_ = (*self).fname_tileset;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).fname_tileset);
	(*dest).fname_tileset = _tmp3_;
	_tmp4_ = (*self).fname_bground;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).fname_bground);
	(*dest).fname_bground = _tmp5_;
	_tmp6_ = (*self).grid_color;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 ((*dest).grid_color);
	(*dest).grid_color = _tmp7_;
	_tmp8_ = (*self).player1;
	_tmp9_ = g_strdup (_tmp8_);
	_g_free0 ((*dest).player1);
	(*dest).player1 = _tmp9_;
	_tmp10_ = (*self).player2;
	_tmp11_ = g_strdup (_tmp10_);
	_g_free0 ((*dest).player2);
	(*dest).player2 = _tmp11_;
	_tmp12_ = (*self).player1_win;
	_tmp13_ = g_strdup (_tmp12_);
	_g_free0 ((*dest).player1_win);
	(*dest).player1_win = _tmp13_;
	_tmp14_ = (*self).player2_win;
	_tmp15_ = g_strdup (_tmp14_);
	_g_free0 ((*dest).player2_win);
	(*dest).player2_win = _tmp15_;
	_tmp16_ = (*self).player1_turn;
	_tmp17_ = g_strdup (_tmp16_);
	_g_free0 ((*dest).player1_turn);
	(*dest).player1_turn = _tmp17_;
	_tmp18_ = (*self).player2_turn;
	_tmp19_ = g_strdup (_tmp18_);
	_g_free0 ((*dest).player2_turn);
	(*dest).player2_turn = _tmp19_;
}

void
theme_destroy (Theme* self)
{
	_g_free0 ((*self).title);
	_g_free0 ((*self).fname_tileset);
	_g_free0 ((*self).fname_bground);
	_g_free0 ((*self).grid_color);
	_g_free0 ((*self).player1);
	_g_free0 ((*self).player2);
	_g_free0 ((*self).player1_win);
	_g_free0 ((*self).player2_win);
	_g_free0 ((*self).player1_turn);
	_g_free0 ((*self).player2_turn);
}

Theme*
theme_dup (const Theme* self)
{
	Theme* dup;
	dup = g_new0 (Theme, 1);
	theme_copy (self, dup);
	return dup;
}

void
theme_free (Theme* self)
{
	theme_destroy (self);
	g_free (self);
}

GType
theme_get_type (void)
{
	static volatile gsize theme_type_id__volatile = 0;
	if (g_once_init_enter (&theme_type_id__volatile)) {
		GType theme_type_id;
		theme_type_id = g_boxed_type_register_static ("Theme", (GBoxedCopyFunc) theme_dup, (GBoxedFreeFunc) theme_free);
		g_once_init_leave (&theme_type_id__volatile, theme_type_id);
	}
	return theme_type_id__volatile;
}

gchar*
theme_get_title (gint id)
{
	Theme _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	_tmp0_ = theme[id];
	_tmp1_ = _tmp0_.title;
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	return result;
}

gchar*
theme_get_player_turn (PlayerID who)
{
	Prefs* _tmp7_;
	Prefs* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	Theme _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result = NULL;
	if (who == PLAYER_ID_PLAYER1) {
		Prefs* _tmp0_;
		Prefs* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		Theme _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp0_ = prefs_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = prefs_get_theme_id (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = theme[_tmp3_];
		_tmp5_ = _tmp4_.player1_turn;
		_tmp6_ = g_strdup (_tmp5_);
		result = _tmp6_;
		return result;
	}
	_tmp7_ = prefs_get_instance ();
	_tmp8_ = _tmp7_;
	_tmp9_ = prefs_get_theme_id (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = theme[_tmp10_];
	_tmp12_ = _tmp11_.player2_turn;
	_tmp13_ = g_strdup (_tmp12_);
	result = _tmp13_;
	return result;
}

gchar*
theme_get_player_win (PlayerID who)
{
	Prefs* _tmp7_;
	Prefs* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	Theme _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result = NULL;
	if (who == PLAYER_ID_PLAYER1) {
		Prefs* _tmp0_;
		Prefs* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		Theme _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp0_ = prefs_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = prefs_get_theme_id (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = theme[_tmp3_];
		_tmp5_ = _tmp4_.player1_win;
		_tmp6_ = g_strdup (_tmp5_);
		result = _tmp6_;
		return result;
	}
	_tmp7_ = prefs_get_instance ();
	_tmp8_ = _tmp7_;
	_tmp9_ = prefs_get_theme_id (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = theme[_tmp10_];
	_tmp12_ = _tmp11_.player2_win;
	_tmp13_ = g_strdup (_tmp12_);
	result = _tmp13_;
	return result;
}

gchar*
theme_get_player (PlayerID who)
{
	Prefs* _tmp7_;
	Prefs* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	Theme _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* result = NULL;
	if (who == PLAYER_ID_PLAYER1) {
		Prefs* _tmp0_;
		Prefs* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		Theme _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp0_ = prefs_get_instance ();
		_tmp1_ = _tmp0_;
		_tmp2_ = prefs_get_theme_id (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = theme[_tmp3_];
		_tmp5_ = _tmp4_.player1;
		_tmp6_ = g_strdup (_tmp5_);
		result = _tmp6_;
		return result;
	}
	_tmp7_ = prefs_get_instance ();
	_tmp8_ = _tmp7_;
	_tmp9_ = prefs_get_theme_id (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = theme[_tmp10_];
	_tmp12_ = _tmp11_.player2;
	_tmp13_ = g_strdup (_tmp12_);
	result = _tmp13_;
	return result;
}

